package com.mh.garrison.controller;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.mh.garrison.constant.Constants;
import com.mh.garrison.mhutils.UUid;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSONObject;

/**
 * 
 * @ClassName:  DeviceController   
 * @Description:TODO(设备服务调用接口)   
 * @author: 铭汉科技—LJF 
 * @date:   2020年7月20日 上午11:15:10   
 *
 */
@RestController
public class DeviceController {

	/**
	 * 单个设备数据变化：水表数据变化
	 * @param jsonParam
	 * @return
	 * @throws IOException
	 */
	@ResponseBody
	@RequestMapping(value = "/na/iocm/devNotify/v1.1.0/updateDeviceData", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
	public String getByJSON1(@RequestBody JSONObject jsonParam) throws IOException {
		
		// 直接将json信息打印出来
		System.out.println("单个设备数据变化————" + jsonParam.toJSONString() + ",大小长度：" + jsonParam.toJSONString().length());

		SimpleDateFormat formatter2 = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss-SSS");
		String formatStr2 = formatter2.format(new Date());
//		System.out.println(formatStr2);// 2017-09-15
		UUid uid = new UUid();		// 生成全球唯一标识
		String uidStr = uid.uuid();

//		FileOutputStream fileOutputStream = null;
		// 把报文保存在本地
		int length = jsonParam.toJSONString().length();
		File file;
		if (length > 500) {
			file = new File( Constants.NEW_NB_METER_FILE + formatStr2 + "_" + uidStr + ".txt");
			if (!file.exists()) {
				try {
					file.createNewFile();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			BufferedWriter out = null;
			try {
				out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file, true)));
				out.write(jsonParam.toJSONString() + "\r\n");
			} catch (Exception e) {
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
			} finally {
				try {
					out.close();
				} catch (IOException e) {
					String causeStr = e.getCause().getMessage();
					System.out.println(">>>>>>>-------------" + causeStr);
				}
			}
		}
//		else {
//			file = new File("E:\\MH_NB\\jingbeiqu\\MeterLogDatas\\" + formatStr2 + "_" + uidStr + ".txt");
//		}
//		File file = new File("E:\\EEMS_NB\\XT_DBC\\LogDatas\\" + formatStr2 + "_" + uidStr + ".txt");
//		File file = new File("E:\\GZ_WATER\\TEST\\LogDatas\\" + formatStr2 + "_" + uidStr + ".txt");


		
		// 创建线程，读取本地报文文件
		// 创建线程
//		ThreadUtil threadUtil = new ThreadUtil();
//		Thread thread = new Thread(threadUtil);
//		if (thread.isAlive() == false) {
//			thread.start();
//		}else {
//			System.out.println("线程已启动");
//		}
		
		// 将获取的json数据封装一层，然后在给返回
		JSONObject result = new JSONObject();
		result.put("msg", "ok");

		return result.toJSONString();
	}
	
	/**
	 * 批量设备数据变化：主要是电表
	 * 
	 * @param jsonParam
	 * @return
	 * @throws IOException
	 */
	@ResponseBody
	@RequestMapping(value = "/na/iocm/devNotify/v1.1.0/updateDeviceDatas", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
	public String getByJSON(@RequestBody JSONObject jsonParam) throws IOException, InterruptedException {

		// 直接将json信息打印出来
		System.out.println("多个设备数据变化————" + jsonParam.toJSONString() + "，大小长度： " + jsonParam.toJSONString().length());

		SimpleDateFormat formatter2 = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss-SSS");
		String formatStr2 = formatter2.format(new Date());
		System.out.println(formatStr2);// 2017-09-15
		UUid uid = new UUid(); // 生成全球唯一标识
		String uidStr = uid.uuid();

		// FileOutputStream fileOutputStream = null;
		// 把报文保存在本地
		// D:\MH_NB\test\SingleMeterLogDatas
		int length = jsonParam.toJSONString().length();
		File file = null;
		if (length > 500) {
			System.out.println("保存水表记录值");
//			file = new File("E:\\MH_NB\\jingbeiqu\\WaterLogDatas\\" + formatStr2 + "_" + uidStr + ".txt");
		} else {
			file = new File("E:\\MH_NB\\jingbeiqu\\MeterLogDatas\\" + formatStr2 + "_" + uidStr + ".txt");
		}
//		File file = new File("D:\\NB_Project\\xiamenshuangqiao\\MeterDataLogs\\" + formatStr2 + "_" + uidStr + ".txt");
		assert file != null;
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
			}
		}
		BufferedWriter out = null;
		try {
			out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file, true)));
			out.write(jsonParam.toJSONString() + "\r\n");
		} catch (Exception e) {
			String causeStr = e.getCause().getMessage();
			System.out.println(">>>>>>>-------------" + causeStr);
		} finally {
			try {
				out.close();
			} catch (IOException e) {
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
			}
		}

		// Thread.sleep(300);
		// 创建线程，读取本地报文文件
		// 创建线程
//		ThreadUtil threadUtil = new ThreadUtil();
//		Thread thread = new Thread(threadUtil);
//		if (thread.isAlive() == false) {
//			thread.start();
//		}else {
//			System.out.println("线程已启动");
//		}
		
		
//		// 文件
//		String fileStr = "D:\\MH_NB\\test\\SingleMeterLogDatas\\" + formatStr2 + "_" + uidStr + ".txt";
//		ThreadUtil.GetTxts(fileStr);

		// 将获取的json数据封装一层，然后在给返回
		JSONObject result = new JSONObject();
		result.put("msg", "ok");

		return result.toJSONString();
	}

	/**
	 * 发送指令回返接收指令 add by ljf on 2018-10-12
	 * 
	 * @param jsonParam
	 * @return
	 * @throws IOException
	 */
	@ResponseBody
	@RequestMapping(value = "/na/iocm/devNotify/v1.1.0/reportCmdExecResult", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
	public String getCMDResult(@RequestBody JSONObject jsonParam) throws IOException {

		// 创建线程
		// ThreadUtil threadUtil = new ThreadUtil();

		// 直接将json信息打印出来
		System.out.println("发送命令返回" + jsonParam.toJSONString());

		SimpleDateFormat formatter2 = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss-SSS");
		String formatStr2 = formatter2.format(new Date());
		System.out.println(formatStr2);// 2017-09-15
		UUid uid = new UUid(); // 生成全球唯一标识
		String uidStr = uid.uuid();

		// FileOutputStream fileOutputStream = null;
		// 把报文保存在本地
		File file = new File("E:\\MH_NB\\jingbeiqu\\MeterCMDDatas\\" + formatStr2 + "_" + uidStr + ".txt");
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		BufferedWriter out = null;
		try {
			out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file, true)));
			out.write(jsonParam.toJSONString() + "\r\n");
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		// // 创建线程，读取本地报文文件
		// Thread thread = new Thread(threadUtil);
		// thread.start();

		// 将获取的json数据封装一层，然后在给返回
		JSONObject result = new JSONObject();
		result.put("msg", "ok");

		return result.toJSONString();
	}
	
}
