package com.mh.garrison.job;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;

import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import com.mh.garrison.mhutils.ByteUtilsWater;
import com.mh.garrison.mhutils.FastJson;

/**
 *
 * @ClassName:  DealWaterLogJob
 * @Description:TODO(定时处理接收到的水表报文记录)
 * @author: 铭汉科技—LJF
 * @date:   2020年7月20日 下午1:56:31
 *
 */
@Component
public class DealWaterLogJob {

	@Scheduled(cron = "0 0/30 * * * ? ")
	public void dealMeterLogJob() {
		String filePath = "E:\\MH_NB\\jingbeiqu\\WaterLogDatas\\";
		GetTxts1(filePath);
	}

	private static void GetTxts1(String filePath) {
		// TODO Auto-generated method stub
		FastJson fastJson = new FastJson();
		File rootFile = new File(filePath);
		String  receive_result = null ;
		if (! rootFile.isDirectory()) {
			System.out.println("文件名----" + rootFile.getAbsolutePath());
			// 读取文件内容
			try { // 防止文件建立或读取失败，用catch捕捉错误并打印，也可以throw
				/* 读入TXT文件 */
				String pathname = rootFile.getAbsolutePath(); // 绝对路径或相对路径都可以，写入文件时演示相对路径
				File filename = new File(pathname); // 要读取以上路径的input.txt文件
				if (filename.length() > 0){
					InputStreamReader reader = new InputStreamReader(
							new FileInputStream(filename)); // 建立一个输入流对象reader
					BufferedReader br = new BufferedReader(reader); // 建立一个对象，它把文件内容转成计算机能读懂的语言
					String line;
					//网友推荐更加简洁的写法
					while ((line = br.readLine()) != null) {
						try {

							// 一次读入一行数据
		//					System.out.println(line);
							String jsonStr = fastJson.analysisFastJson(line);
		//					System.out.println(jsonStr);

							// 解析onlineCode
							ByteUtilsWater byteUtils = new ByteUtilsWater();
							receive_result = byteUtils.analysisFastJson1(jsonStr);

						} catch (Exception e) {
							// TODO: handle exception
							e.printStackTrace();
						}
					}
					reader.close();
					br.close();

					// 删除filename
					if (receive_result.equals("success")) {
						System.out.println("------------------------解析成功------------------");
						if (filename.exists()) {
							filename.delete();
							System.out.println(filename + "删除成功");
						}
					}else {
						System.out.println("------------------------解析失败------------------");
					}
				} else {
					// 删除filename
					if (filename.exists()) {
						filename.delete();
						System.out.println("删除成功");
					}
				}

			} catch (Exception e) {
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
			}
		}else {
			// 递归查询文件内容
			String[] fileList = rootFile.list();
			assert fileList != null;
			for (String s : fileList) {
				filePath = rootFile.getAbsolutePath() + "\\" + s;
				try {
					GetTxts1(filePath);
				} catch (Exception e) {
					// TODO: handle exception
					e.printStackTrace();
//						continue;
				}
			}
		}
	}
}
