package com.mh.garrison.job;

import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

import com.mh.garrison.mhutils.*;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * 
 * @ClassName:  QueryDeviceJob   
 * @Description:TODO(定时查询状态设备信息)   
 * @author: 铭汉科技—LJF 
 * @date:   2020年7月20日 上午9:06:07   
 *
 */
@Component
public class QueryDeviceJob {
	
	@Scheduled(cron = "0 0 0-4 * * ? ")
	public void queryDevice() {
		System.out.println("每四个小时定时查询设备状态值");
		// TODO Auto-generated method stub
		// TODO Auto-generated method stub
		// Two-Way Authentication
		HttpsUtil httpsUtil = new HttpsUtil();
		try {
			httpsUtil.initSSLConfigForTwoWay();
		} catch (Exception e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}

		// Authentication，get token
		String accessToken = null;
		try {
			accessToken = login(httpsUtil);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		// Please make sure that the following parameter values have been modified in
		// the Constant file.
		String appId = Constant.APPID;
		String urlQueryDevices = Constant.QUERY_DEVICES;

		// please replace the pageNo and pageSize, when you use the demo.
		Integer pageNo = 0;
		Integer pageSize = 500;

		Map<String, String> paramQueryDevices = new HashMap<String, String>();
		paramQueryDevices.put("appId", appId);
		paramQueryDevices.put("pageNo", pageNo.toString());
		paramQueryDevices.put("pageSize", pageSize.toString());

		Map<String, String> header = new HashMap<String, String>();
		header.put(Constant.HEADER_APP_KEY, appId);
		header.put(Constant.HEADER_APP_AUTH, "Bearer" + " " + accessToken);

		StreamClosedHttpResponse bodyQueryDevices = null;
		try {
			bodyQueryDevices = httpsUtil.doGetWithParasGetStatusLine(urlQueryDevices, paramQueryDevices, header);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// System.out.println("请求地址----" + urlQueryDevices);
		// System.out.println("请求参数----" + paramQueryDevices);
		// System.out.println("请求头部----" + header);

		System.out.println("QueryDevices, response content:");
		System.out.println(bodyQueryDevices.getStatusLine());
		System.out.println(bodyQueryDevices.getContent());
		System.out.println();

		String state;
		try {

			FastJsonUtil fastJsonUtil = new FastJsonUtil();
			state = fastJsonUtil.analysisFastJson(bodyQueryDevices.getContent());
			if (state.equals("success")) {
				System.out.println("查询设备信息成功！！");
			} else {
				System.out.println("查询设备信息失败！！");
			}
			// String deviceMessage = jsonNode.get("devices").toString();
			// System.out.println(deviceMessage);
			// List<DeviceMessage> beanList = objectMapper.readValue(deviceMessage, new
			// TypeReference<List<DeviceMessage>>() {});
			// System.out.println(beanList);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	/**
	 * Authentication，get token
	 */
	@SuppressWarnings("unchecked")
	public static String login(HttpsUtil httpsUtil) throws Exception {

		String appId = Constant.APPID;
		String secret = Constant.SECRET;
		String urlLogin = Constant.APP_AUTH;

		Map<String, String> paramLogin = new HashMap<String, String>();
		paramLogin.put("appId", appId);
		paramLogin.put("secret", secret);

		StreamClosedHttpResponse responseLogin = httpsUtil.doPostFormUrlEncodedGetStatusLine(urlLogin, paramLogin);

		System.out.println("app auth success,return accessToken:");
		System.out.print(responseLogin.getStatusLine());
		System.out.println(responseLogin.getContent());
		System.out.println();

		Map<String, String> data = new HashMap<String, String>();
		data = JsonUtil.jsonString2SimpleObj(responseLogin.getContent(), data.getClass());
		return data.get("accessToken");
	}


	/**
	 * 查询水表状态值
	 */
	@Scheduled(cron = "0 0 0-4 * * ? ")
	public void queryWaterDevice() {
		System.out.println("每四个小时定时查询设备状态值");
		// TODO Auto-generated method stub
		// TODO Auto-generated method stub
		// Two-Way Authentication
		HttpsUtil httpsUtil = new HttpsUtil();
		try {
			httpsUtil.initSSLConfigForTwoWay();
		} catch (Exception e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}

		// Authentication，get token
		String accessToken = null;
		try {
			accessToken = loginWater(httpsUtil);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		// Please make sure that the following parameter values have been modified in
		// the Constant file.
		String appId = ConstantWater.APPID;
		String urlQueryDevices = ConstantWater.QUERY_DEVICES;

		// please replace the pageNo and pageSize, when you use the demo.
		Integer pageNo = 0;
		Integer pageSize = 500;

		Map<String, String> paramQueryDevices = new HashMap<String, String>();
		paramQueryDevices.put("appId", appId);
		paramQueryDevices.put("pageNo", pageNo.toString());
		paramQueryDevices.put("pageSize", pageSize.toString());

		Map<String, String> header = new HashMap<String, String>();
		header.put(Constant.HEADER_APP_KEY, appId);
		header.put(Constant.HEADER_APP_AUTH, "Bearer" + " " + accessToken);

		StreamClosedHttpResponse bodyQueryDevices = null;
		try {
			bodyQueryDevices = httpsUtil.doGetWithParasGetStatusLine(urlQueryDevices, paramQueryDevices, header);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// System.out.println("请求地址----" + urlQueryDevices);
		// System.out.println("请求参数----" + paramQueryDevices);
		// System.out.println("请求头部----" + header);

		System.out.println("QueryDevices, response content:");
		System.out.println(bodyQueryDevices.getStatusLine());
		System.out.println(bodyQueryDevices.getContent());
		System.out.println();

		String state;
		try {

			FastJsonUtil fastJsonUtil = new FastJsonUtil();
			state = fastJsonUtil.analysisFastJson(bodyQueryDevices.getContent());
			if (state.equals("success")) {
				System.out.println("查询设备信息成功！！");
			} else {
				System.out.println("查询设备信息失败！！");
			}
			// String deviceMessage = jsonNode.get("devices").toString();
			// System.out.println(deviceMessage);
			// List<DeviceMessage> beanList = objectMapper.readValue(deviceMessage, new
			// TypeReference<List<DeviceMessage>>() {});
			// System.out.println(beanList);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	/**
	 * Authentication，get token
	 */
	@SuppressWarnings("unchecked")
	public static String loginWater(HttpsUtil httpsUtil) throws Exception {

		String appId = ConstantWater.APPID;
		String secret = ConstantWater.SECRET;
		String urlLogin = ConstantWater.APP_AUTH;

		Map<String, String> paramLogin = new HashMap<String, String>();
		paramLogin.put("appId", appId);
		paramLogin.put("secret", secret);

		StreamClosedHttpResponse responseLogin = httpsUtil.doPostFormUrlEncodedGetStatusLine(urlLogin, paramLogin);

		System.out.println("app auth success,return accessToken:");
		System.out.print(responseLogin.getStatusLine());
		System.out.println(responseLogin.getContent());
		System.out.println();

		Map<String, String> data = new HashMap<String, String>();
		data = JsonUtil.jsonString2SimpleObj(responseLogin.getContent(), data.getClass());
		return data.get("accessToken");
	}
}
