package com.mh.garrison.job;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.List;

import com.mh.garrison.mhutils.MSGClient;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import com.mh.garrison.entity.MSGEntity;
import com.mh.garrison.service.MSGService;

/**
 * 
 * @ClassName:  SendMSGJob   
 * @Description:TODO(定时发送短信信息)   
 * @author: 铭汉科技—LJF 
 * @date:   2020年7月20日 上午9:00:39   
 *
 */
@Component
public class SendMSGJob {
	
	private final MSGService msgService;
	
	public SendMSGJob(MSGService msgService) {
		// TODO Auto-generated constructor stub
		this.msgService = msgService;
	}
	
//	@Scheduled(cron = "0 0 0/1 * * ? ")
	public void sendMSG() {
		System.out.println("每小时执行一次定时发送短信提醒指令");
		try {
			boolean result = sendCellphoneMessage();
			if (result) {
				System.out.println("---------------已发送手机短信---------------");
			} else {
				System.out.println("---------未发送手机短信或者没有结果集-----------");
			}
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public boolean sendCellphoneMessage() throws InterruptedException {
		boolean returnResult = false;
		String userName = "jbqznjf";
		String password = "dT6pH6rQ1";
		List<MSGEntity> msgEntities = msgService.queryMSGList();
		
		for (int i = 0; i < msgEntities.size(); i++) {
//			String content = "尊敬的" + msgEntities.get(i).getHouseNum() + "房客户，您好，您目前"+ msgEntities.get(i).getRemark()+"余额为 "
//					+ msgEntities.get(i).getBalanceMoney() + " 元，为了您的正常使用，请您尽快到指定站点充值，谢谢！" + "【校园电表系统】";
			String content = msgEntities.get(i).getSendMsg();
			String mobile = msgEntities.get(i).getCellphoneNum();
			int send_time = msgEntities.get(i).getSendTime() + 1;
			String remark = msgEntities.get(i).getRemark();
			String createDate = msgEntities.get(i).getCreateDate();
			// String content1 = "你好!【校园电表系统】,电费!【校园电表系统】";
			// String mobile = "18011970201,15277338501,18922383731";
			MSGClient msgClient = null;
			String result = null;
			try {
				msgClient = new MSGClient(userName, password);
				result = msgClient.mt(URLEncoder.encode(content, "UTF-8"), mobile, "", "", "", "");
				System.out.println("发送结果--------" + result);
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Thread.sleep(200);
			String strCode = result.split("\n")[0];
			long code = 0;
			code = Long.parseLong(strCode);
			String Info = null;
			if (code > 0) {// 成功提交
				String sendStatus = msgService.updateSysSms("已发送",mobile, send_time, createDate);
				if (sendStatus.equalsIgnoreCase("success")) {
					Info = "发送成功";
					System.out.println("返回信息：" + Info + "--" + code + "--" + msgClient.getPwd());
					returnResult = true;
				} else {
					Info = "发送失败";
					returnResult = false;
				}
			} else {
				msgService.updateSysSms("未发送",mobile, send_time, createDate);
				returnResult = false;
				if (code == 0) {
					Info = "发送失败";
				} else if (code == -1) { // 用户名密码不正确
					Info = "用户名密码不正确";
				} else if (code == -2) { // 必填选项为空
					Info = "必填选项为空";
				} else if (code == -3) { // 短信内容0个字节
					Info = "短信内容0个字节";
				} else if (code == -4) { // 0个有效号码
					Info = "0个有效号码";
				} else if (code == -5) { // 余额不够
					Info = "余额不够";
				} else if (code == -10) { // 用户被禁用
					Info = "用户被禁用";
				} else if (code == -11) { // 短信内容过长
					Info = "短信内容过长";
				} else if (code == -12) { // 用户无扩展权限
					Info = "无扩展权限";
				} else if (code == -13) { // IP地址校验错
					Info = "IP校验错误";
				} else if (code == -14) { // 内容解析异常
					Info = "内容解析异常";
				} else {
					Info = "未知错误";
				}
			}
			assert msgClient != null;
			System.out.println("返回信息：" + Info + "--" + code + "--" + msgClient.getPwd());
		}
		return returnResult;
	}
}
