package com.mh.garrison.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import com.mh.garrison.entity.MSGEntity;

/**
 * 
 * @ClassName:  MSGMapper   
 * @Description:TODO(查询需要发送短信的客户)   
 * @author: 铭汉科技—LJF 
 * @date:   2020年7月20日 上午9:20:46   
 *
 */
@Mapper
public interface MSGMapper {
	
	@Results({ 
		@Result(property = "houseNum", column = "house_num"),
		@Result(property = "cellphoneNum", column = "cellphone_num"),
		@Result(property = "balanceMoney", column = "balance_money"), 
		@Result(property = "remark", column = "remark"),
		@Result(property = "sendTime", column = "send_time"),
		@Result(property = "createDate", column = "create_date"),
		@Result(property = "sendMsg", column = "send_msg")
	})
	@Select("select house_num, cellphone_num, balance_money, remark, send_time, convert(varchar(25),create_date,121) as create_date, send_msg from sys_sms where is_send = '未发送' and send_time < 3 order by create_date desc")
	List<MSGEntity> queryMSGList();
	
//	@Update("update sys_sms set is_send = '已发送', send_time = #{sendTime} where cellphone_num = #{cellphone} and convert(varchar(25),create_date,121) = #{createDate}")
//	int updateSysSms(@Param("cellphone") String cellphone,@Param("sendTime") int sendTime , @Param("createDate") String createDate);

	@Update("update sys_sms set is_send = #{isSend}, send_time = #{sendTime} where cellphone_num = #{cellphone} and convert(varchar(25),create_date,121) = #{createDate}")
	int updateSysSms(@Param("isSend") String isSend,@Param("cellphone") String cellphone,@Param("sendTime") int sendTime , @Param("createDate") String createDate);

}
