package com.mh.garrison.mapper;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.mapping.StatementType;

import com.mh.garrison.entity.MeterNowBean;

@Mapper
public interface MeterNowMapper {
	
	// 查询房间号 2018-09-28 by ljf
//	@Select("select house_num from house where id = (select parent_id from house where device_num = #{device_num})")
	// 查询房间号 2018-12-18 by ljf
	@Select("select top 1 HouseNo from MeterInstall where MeterID = #{device_num}")
	String findHouse(@Param("device_num") String device_num);
	
	// 厦门双桥查询电表名称
	@Select("select top 1 ISNULL(MeterName,'') from MeterInstall where MeterID = #{device_num}")
	String findHouse1(@Param("device_num") String device_num);
	@Select("select top 1 isnull(building_name,'') from MeterInstall where MeterID = #{device_num}")
	String findBuildingName1(@Param("device_num") String device_num);
	
	// 查询楼层建筑 2018-09-28 by ljf
	@Select("select top 1 house_num from house where id = (select parent_id from house where house_num = #{house_num})")
	String findBuilding(@Param("house_num") String house_num);
	
	// 由于数据库修改，从而查询楼栋建筑2018-12-18 by ljf
//	@Select("select house_num from house where id = "
//			+ "(select parent_id from house where id = (select parent_id from house where house_num = #{house_num}))")
	@Select("select top 1 building_name from MeterInstall where MeterID = #{device_num}")
	String findBuildingName(@Param("device_num") String device_num);
	
	// 检查是否有数值
	@Select("select top 1 count(mt_num) from mt_now where mt_time = #{mt_time}")
	int checkMeterNow(MeterNowBean meterNowBean);
	
	// 检查是否有对应的表号
	@Select("select top 1 count(mt_num) from mt_now where mt_num = #{mt_num}")
	<T> int checkMeterId(T meterNowBean);
	
	// 增加数据内容到mt_now表中 update by ljf on 2018-11-12
	@Insert("insert into mt_now(mt_num,mt_electric,mt_state,mt_device_id,limited_power,mt_time,house_num,building_name,grade)"
			+ " values (#{mt_num},#{mt_electric},#{mt_state},#{mt_device_id},#{limited_power},#{mt_time},#{house_num},#{building_name},#{grade})")
	<T> int insertAll(T meterNowBean);
	
	// 当电表发生数据变化时，更新数据内容到meter_now表中
	@Update("update mt_now set mt_electric=#{mt_electric}, mt_time=#{mt_time}, mt_state=#{mt_state}, limited_power=#{limited_power}"
			+ " where mt_num = #{mt_num}")
	<T> int updateAll(T meterNowBean);
	
	// 执行存储过程，计算电表以及地区的值
	@Select({"exec pro_calc_hoursmeter"})
	@Options(statementType=StatementType.CALLABLE)
	String exePro_calc_Meter();

}
