package com.mh.garrison.mapper;

import com.mh.garrison.entity.WaterBean;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.springframework.dao.DataAccessException;

import java.util.List;

@Mapper
public interface WaterMapper {
	
	@Select("select * from t_water")
	List<WaterBean> findAllWater();
	
	@Select("select * from t_water where waterId = #{waterId}")
	WaterBean findByWaterId(@Param("waterId") String waterId);
	
	@Select("select * from t_water where waterId = #{waterId}")
	int findByWaterId1(@Param("waterId") String waterId);
	
	@Insert("insert into t_water(waterId) values (#{waterId})")
	int insert(@Param("waterId") String waterId);
	
	@Insert("insert into t_water(waterId, imsi, imei, currentFlow, currentDate, manufacturerId)"
			+ " values (#{waterId}, #{imsi}, #{imei}, #{currentFlow}, #{currentDate}, #{manufacturerId})")
	int insertAll(WaterBean waterBean) throws DataAccessException;
	
	@Update("update t_water set currentFlow=#{currentFlow}, currentDate=#{currentDate} where waterId=#{waterId}")
	int update(WaterBean waterBean);
	
	@Delete("delete from t_water where waterId=#{waterId}")
	int delete(String waterId);
	
	// 查询IMEI号
	@Select("select imei_num from house where device_num = #{device_num}")
	String findImei(@Param("device_num") String device_num);
	
	// 查询房间号
	@Select("select house_num from house where id = (select parent_id from house where device_num = #{device_num})")
	String findHouse1(@Param("device_num") String device_num);
	
	// 查询房间号 update on 2018-12-25 by ljf
	@Select("select top 1 HouseNo from MeterInstall where MeterID = #{device_num}")
	String findHouse(@Param("device_num") String device_num);
	
	// 查询是否有实时的记录
	@Select("select top 1 count(id) from wt_now where wt_num = #{wt_num}")
	int findResult(@Param("wt_num") String wt_num);
	
	// 插入水表实时数据 update by ljf on 2019-12-24
	@Insert("insert into wt_now(wt_num,house_num,IMEI,IMSI,cur_flow,cur_date,manufacture_id,grade)" +
			"	values(#{wt_num},#{house_num},#{IMEI},#{IMSI},#{cur_flow},#{cur_date},#{manufacture_id},#{grade})")
	int insertWtNowAll(WaterBean waterBean);
//	@Insert("insert into wt_now(wt_num,house_num,IMEI,IMSI,cur_flow,cur_date,manufacture_id,grade,contra_flow,push_button,store,valve_status,valve_unusual,communication_status,sos_key,voltage,reflux_flow)" +
//			"	values(#{wt_num},#{house_num},#{IMEI},#{IMSI},#{cur_flow},#{cur_date},#{manufacture_id},#{grade},#{contra_flow},#{push_button},#{store},#{valve_status},#{valve_unusual},#{communication_status},#{sos_key},#{voltage},#{reflux_flow})")
//	int insertWtNowAll(WaterBean waterBean);
	
	// 水表实时表存在相同的数据，则进行更新，update by ljf on 2019-12-24
	@Update("update wt_now set cur_flow = #{cur_flow}, cur_date = #{cur_date} where wt_num=#{wt_num}")
	int updateWtNow(WaterBean waterBean);
//	@Update("update wt_now set cur_flow = #{cur_flow}, cur_date = #{cur_date},voltage = #{voltage}, contra_flow = #{contra_flow},push_button = #{push_button},store = #{store},valve_status = #{valve_status},valve_unusual = #{valve_unusual},communication_status = #{communication_status},sos_key = #{sos_key},reflux_flow = #{reflux_flow} where wt_num=#{wt_num}")
//	int updateWtNow(WaterBean waterBean);

}
