package com.mh.garrison.mhutils;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import org.springframework.context.ApplicationContext;

import com.mh.garrison.entity.WaterBean;
import com.mh.garrison.entity.WaterHistoryBean;
import com.mh.garrison.service.WaterHistoryService;
import com.mh.garrison.service.WaterServices;

public class ByteUtilsWater {

	// 添加之后能够对mapper调用
	private ApplicationContext applicationContext = SpringUtils.getApplicationContext();

	private WaterServices waterService = applicationContext.getBean(WaterServices.class);

	private WaterHistoryService waterHistoryService = applicationContext.getBean(WaterHistoryService.class);

	WaterBean water = new WaterBean();
	WaterHistoryBean wtHistoryBean = new WaterHistoryBean();

	/**
	 * 十进制转成十六进制： Integer.toHexString(int i) 十进制转成八进制： Integer.toOctalString(int i)
	 * 十进制转成二进制 Integer.toBinaryString(int i) 十六进制转成十进制：
	 * Integer.valueOf("FFFF",16).toString() 八进制转成十进制：
	 * Integer.valueOf("876",8).toString() 二进制转十进制：*
	 * Integer.valueOf("0101",2).toString()
	 */
	// 光电直读水表解析报文
	public String analysisFastJson(String receiveData) throws Exception {

		// SqlSession session = SQLDataSourceConfig.openSession();
		String return_result = "success";
		// // 水表ID
		// String WaterID = receiveData.substring(14, 24);
		// WaterID = changePosition(WaterID);
		// // System.out.println("水表ID——————" + WaterID);
		// water.setWt_num(WaterID);
		//
		// // 厂商ID
		// String manufactureID = receiveData.substring(24, 28);
		// manufactureID = changePosition(manufactureID);
		// // System.out.println("厂商ID——————" + manufactureID);
		// water.setManufacture_id(manufactureID);;

		// 水表ID
		String WaterID = receiveData.substring(14, 24);
		WaterID = changePosition(WaterID);
		// System.out.println("水表ID——————" + WaterID);

		// 厂商ID
		String manufactureID = receiveData.substring(24, 28);
		manufactureID = changePosition(manufactureID);
		// System.out.println("厂商ID——————" + manufactureID);

		// 增加水表号为12位数 update by ljf on 2019-08-27
		String is_status = manufactureID.substring(2, 4);
		System.out.println(is_status);
		if (is_status.equals("06")) {
			WaterID = receiveData.substring(14, 24);
			WaterID = changePosition(WaterID);
			System.out.println("水表ID——————" + WaterID);
			water.setWt_num(WaterID);

			manufactureID = receiveData.substring(24, 28);
			manufactureID = changePosition(manufactureID);
			System.out.println("厂商ID——————" + manufactureID);
			water.setManufacture_id(manufactureID);
		} else {
			WaterID = receiveData.substring(14, 26);
			WaterID = changePosition(WaterID);
			System.out.println("水表ID——————" + WaterID);
			water.setWt_num(WaterID);

			manufactureID = receiveData.substring(26, 28);
			manufactureID = changePosition(manufactureID);
			System.out.println("厂商ID——————" + manufactureID);
			water.setManufacture_id(manufactureID);
		}

		// 时间
		String dateString = receiveData.substring(28, 42);
		dateString = dateString.substring(0, 4) + "-" + dateString.substring(4, 6) + "-" + dateString.substring(6, 8)
				+ " " + dateString.substring(8, 10) + ":" + dateString.substring(10, 12) + ":"
				+ dateString.substring(12, 14);
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

		Date date = sdf.parse(dateString);
		dateString = sdf.format(date);
		// System.out.println("时间————————" + dateString);
		water.setCur_date(dateString);

		// 按日
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd");
		Date date1 = sdf1.parse(dateString);
		String dateString1 = sdf1.format(date1);

		// 电池电压
		String Battery = receiveData.substring(44, 48);
		Battery = changePosition(Battery);
		Battery = hex2Binary(Battery);
		Battery = Integer.valueOf(Battery, 2).toString();
		double voltage = Double.parseDouble(Battery) / 100;
		// 2019-12-06 update by ljf
		water.setVoltage(voltage);
		System.out.println("电池电压————" + voltage + " V");

		// 累计上线成功次数
		String onlineSum = receiveData.substring(48, 52);
		onlineSum = changePosition(onlineSum);
		onlineSum = hex2Binary(onlineSum);
		onlineSum = Integer.valueOf(onlineSum, 2).toString();
		// System.out.println("累计上线成功次数——" + onlineSum);

		// 累计上线失败次数
		String failedSum = receiveData.substring(52, 56);
		failedSum = changePosition(failedSum);
		failedSum = hex2Binary(failedSum);
		failedSum = Integer.valueOf(failedSum, 2).toString();
		// System.out.println("累计上线失败次数——" + failedSum);

		// 状态字
		String stateStr = receiveData.substring(56, 64);
		// System.out.println("状态字————————" + stateStr);
		// update by ljf on 2019-12-24
		// 状态字
		System.out.println("状态字————————" + stateStr);
		System.out.println("状态字1--------------------" + hex2Binary(stateStr.substring(0, 2)));
		System.out.println("状态字1.0：逆流标志                "
				+ (hex2Binary(stateStr.substring(0, 2)).substring(7, 8).equalsIgnoreCase("0") ? "正常" : "逆流"));
		System.out.println("状态字1.1：按键异常标志        "
				+ (hex2Binary(stateStr.substring(0, 2)).substring(6, 7).equalsIgnoreCase("0") ? "正常" : "故障"));
		System.out.println("状态字1.3：存储故障标志        "
				+ (hex2Binary(stateStr.substring(0, 2)).substring(5, 6).equalsIgnoreCase("0") ? "正常" : "故障"));
		System.out.println("状态字2--------------------" + hex2Binary(stateStr.substring(2, 4)));
		System.out.println("状态字2.7：阀门状态                "
				+ (hex2Binary(stateStr.substring(2, 4)).substring(0, 1).equalsIgnoreCase("0") ? "开阀" : "关阀"));
		System.out.println("状态字2.6：阀门异常                "
				+ (hex2Binary(stateStr.substring(2, 4)).substring(1, 2).equalsIgnoreCase("0") ? "正常" : "异常"));
		System.out.println("状态字2.5：流量通讯异常标志 "
				+ (hex2Binary(stateStr.substring(2, 4)).substring(2, 3).equalsIgnoreCase("0") ? "正常" : "异常"));
		System.out.println("状态字3--------------------" + hex2Binary(stateStr.substring(4, 6)));
		System.out.println("状态字3.4：应急按键标志        "
				+ (hex2Binary(stateStr.substring(4, 6)).substring(3, 4).equalsIgnoreCase("0") ? "正常" : "已关阀三天"));
		System.out.println("状态字4-------" + hex2Binary(stateStr.substring(6, 8)));

		water.setContra_flow(Integer.parseInt(hex2Binary(stateStr.substring(0, 2)).substring(7, 8)));
		water.setPush_button(Integer.parseInt(hex2Binary(stateStr.substring(0, 2)).substring(6, 7)));
		water.setStore(Integer.parseInt(hex2Binary(stateStr.substring(0, 2)).substring(5, 6)));
		water.setValve_status(Integer.parseInt(hex2Binary(stateStr.substring(2, 4)).substring(0, 1)));
		water.setValve_unusual(Integer.parseInt(hex2Binary(stateStr.substring(2, 4)).substring(1, 2)));
		water.setCommunication_status(Integer.parseInt(hex2Binary(stateStr.substring(2, 4)).substring(2, 3)));
		water.setSos_key(Integer.parseInt(hex2Binary(stateStr.substring(4, 6)).substring(3, 4)));

		// 软件版本
		String SofewareStr = receiveData.substring(82, 86);
		SofewareStr = changePosition(SofewareStr);
		SofewareStr = hex2Binary(SofewareStr);
		SofewareStr = Integer.valueOf(SofewareStr, 2).toString(); // 主版本
		String SofewareStr1 = receiveData.substring(86, 88);
		SofewareStr1 = hex2Binary(SofewareStr1);
		SofewareStr1 = Integer.valueOf(SofewareStr1, 2).toString(); // 子版本
		// System.out.println("软件主版本——" + SofewareStr + ",软件子版本——" + SofewareStr1);

		// IMSI 号
		String IMSIStr = receiveData.substring(88, 104);
		water.setIMSI(IMSIStr);

		// 当前累计流量
		String totalFlow = receiveData.substring(104, 114);
		totalFlow = changePosition(totalFlow);
		totalFlow = hex2Binary(totalFlow);
		totalFlow = Integer.valueOf(totalFlow, 2).toString();
		Double flow = Double.parseDouble(totalFlow) / 10;
		// System.out.println("当前累计流量————" + flow + " L");
		water.setCur_flow(String.valueOf(flow / 1000));

		// 当前累计逆流量
		String reverseFlow = receiveData.substring(114, 124);
		reverseFlow = changePosition(reverseFlow);
		reverseFlow = hex2Binary(reverseFlow);
		reverseFlow = Integer.valueOf(reverseFlow, 2).toString();
		Double flow1 = Double.parseDouble(reverseFlow) / 10;
		System.out.println("当前累计逆流量————" + flow1 + " L");
		water.setReflux_flow(flow1 / 1000);

		// imei号
		String imei = waterService.findImei(WaterID);
		water.setIMEI(imei);

		// 房间号
		String house_num = waterService.findHouse(WaterID);
		water.setHouse_num(house_num);
		water.setGrade(0);

		int nowSum = waterService.findResult(WaterID);

		if (nowSum != 0) {
			System.out.println("已存在水表");
			int updateResult = waterService.updateWtNow(water);
			if (updateResult == 1) {
				System.out.println("更新水表成功");
			} else {
				System.out.println("更新水表失败");
			}
		} else {
			// 插入数据库
			int result = waterService.insertWtNowAll(water);
			if (result == 1) {
				System.out.println("新增水表成功");
			} else {
				System.out.println("新增水表失败");
			}
		}
		// wtHistoryBean.setWt_num(WaterID);
		// wtHistoryBean.setHouse_num(house_num);
		// wtHistoryBean.setIMEI(imei);
		// wtHistoryBean.setIMSI(IMSIStr);
		// wtHistoryBean.setCur_flow(flow/1000);
		// wtHistoryBean.setCur_date(dateString1); //2018-07-01
		// wtHistoryBean.setManufacture_id(manufactureID);
		// wtHistoryBean.setGrade(0);
		// wtHistoryBean.setYear_date(dateString1.substring(0, 4));
		// waterDayBean.setMonth_date(dateString1.substring(0,7));
		// int a1 = waterHistoryMapper.checkSame(wtHistoryBean);
		// if (a1 == 0) {
		// waterHistoryMapper.insertAll(wtHistoryBean);
		//// System.out.println("插入第 " + (i+1) + " 日数据成功");
		// }else {
		// // 更新当天水表的日结数
		// waterHistoryMapper.update(wtHistoryBean);
		// }

		// 日结数组
		String dateReport = receiveData.substring(124, 126);
		dateReport = hex2Binary(dateReport);
		dateReport = Integer.valueOf(dateReport, 2).toString();
		// System.out.println("日结数组数————" + dateReport);

		// 日结数据
		int days = Integer.parseInt(dateReport);

		String dateString2 = dateString1;
		SimpleDateFormat sj = new SimpleDateFormat("yyyy-MM-dd");
		Date d = sj.parse(dateString2);
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(d);
		// calendar.add(Calendar.DATE, -27);
		// update by ljf on 2019-10-16 解决存储数据库出现超出当前报文的时间
		calendar.add(Calendar.DATE, -Integer.parseInt(dateReport));
		dateString2 = sj.format(calendar.getTime());
		long dif;
		Date date2 = new Date();
		// System.out.println("29天前：" + sj.format(calendar.getTime()));
		for (int i = 0; i < days; i++) {
			String dayReport = receiveData.substring((128 + i * 10), (128 + (i + 1) * 10));
			dayReport = changePosition(dayReport);
			if (dayReport.equals("ffffffffff")) {
				dif = sdf1.parse(dateString2).getTime() + 86400 * 1000; // 加一天
				date2.setTime(dif);
				dateString2 = sdf1.format(date2);
				continue;
			}
			dayReport = hex2Binary(dayReport);
			dayReport = Integer.valueOf(dayReport, 2).toString();
			Double dayflow = Double.parseDouble(dayReport) / 10;

			// 加一天时间
			try {
				dif = sdf1.parse(dateString2).getTime() + 86400 * 1000; // 加一天
				date2.setTime(dif);
				dateString2 = sdf1.format(date2);
				System.out.println("加一天之后： " + i + "、" + dateString2 + "/" + (dayflow / 1000));
				System.out.println("第  " + dateString2 + " 日的数据————" + dayflow + " L");
				wtHistoryBean.setWt_num(WaterID);
				wtHistoryBean.setHouse_num(house_num);
				wtHistoryBean.setIMEI(imei);
				wtHistoryBean.setIMSI(IMSIStr);
				wtHistoryBean.setCur_flow(String.valueOf(dayflow / 1000));
				wtHistoryBean.setCur_date(dateString2); // 2018-07-01
				wtHistoryBean.setManufacture_id(manufactureID);
				wtHistoryBean.setGrade(0);

				System.out.println("水表表号-------------" + WaterID);
				int a3 = waterHistoryService.insertAll(wtHistoryBean);
				// int a3 = waterHistoryMapper.insertAll(wtHistoryBean);
				System.out.println("-----------------" + a3 + "--------------------------");
				if (a3 == 1) {
					// session.commit();
					// System.out.println(wtHistoryBean.toString());
					// Thread.sleep(5000);
					int a2 = waterHistoryService.checkSame(wtHistoryBean);
					System.out.println("-----------------" + a2 + "--------------------------");
					if (a2 == 1) {
						// System.out.println(wtHistoryBean.toString());
						System.out.println("插入历史流水表成功");
					} else {
						return_result = "fail";
					}
				}
			} catch (Exception e) {
				// TODO: handle exception
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
				continue;
			}
		}
		// String dateString3 = dateString1;
		// for (int i = 0; i < days; i++) {
		//// if (i == 28) {
		//// break;
		//// }
		// String dayReport = receiveData.substring((128 + i*10), (128 + (i+1)*10));
		// dayReport = changePosition(dayReport);
		// dayReport = hex2Binary(dayReport);
		// dayReport = Integer.valueOf(dayReport,2).toString();
		// Double dayflow = Double.parseDouble(dayReport)/10;
		//
		// // 前一天的水表读数
		//// String lastDayReport = receiveData.substring((128 + (i+1)*10), endIndex);
		//
		//// System.out.println("第 " + dateString1 + " 日的数据————" + dayflow + " L");
		//
		// //减一天时间
		// try {
		// long dif = sdf1.parse(dateString3).getTime()-86400*1000; // 减一天
		// Date date2 = new Date();
		// date2.setTime(dif);
		// dateString3 = sdf1.format(date2);
		//// System.out.println("减少一天之后： " + sdf1.format(date2));
		// } catch (Exception e) {
		// // TODO: handle exception
		// e.printStackTrace();
		// }
		//
		// waterDayBean.setWater_id(WaterID);
		// waterDayBean.setCurrentFlow(dayflow);
		// waterDayBean.setGrade(0);
		// waterDayBean.setDate(dateString3);
		//
		// String a3 = waterDayMapper.checkCalc(waterDayBean);
		// if (a3 == null) {
		// // 执行存储过程，计算用量
		// waterDayMapper.exeProcedure(waterDayBean);
		// }
		// }

		// // 更新当天的计算值
		// waterDayBean.setWater_id(WaterID);
		// waterDayBean.setCurrentFlow(flow);
		// waterDayBean.setGrade(0);
		// waterDayBean.setCur_date(dateString1);
		// waterDayMapper.exeProcedure(waterDayBean);
		//
		// // 更新地区
		// waterDayMapper.execPro_Cheack_Areas(WaterID);

		System.out.println("解析成功");
		return return_result;
	}

	// 无磁水表解析报文
	public String analysisFastJson1(String receiveData) throws Exception {

		// SqlSession session = SQLDataSourceConfig.openSession();
		String return_result = "success";

		// 水表ID
		String WaterID = receiveData.substring(14, 24);
		WaterID = changePosition(WaterID);
		// System.out.println("水表ID——————" + WaterID);

		// 厂商ID
		String manufactureID = receiveData.substring(24, 28);
		manufactureID = changePosition(manufactureID);
		// System.out.println("厂商ID——————" + manufactureID);

		// 增加水表号为12位数 update by ljf on 2019-08-27
		String is_status = manufactureID.substring(2, 4);
		System.out.println(is_status);
		if (is_status.equals("06")) {
			WaterID = receiveData.substring(14, 24);
			WaterID = changePosition(WaterID);
			System.out.println("水表ID——————" + WaterID);
			water.setWt_num(WaterID);

			manufactureID = receiveData.substring(24, 28);
			manufactureID = changePosition(manufactureID);
			System.out.println("厂商ID——————" + manufactureID);
			water.setManufacture_id(manufactureID);
		} else {
			WaterID = receiveData.substring(14, 26);
			WaterID = changePosition(WaterID);
			System.out.println("水表ID——————" + WaterID);
			water.setWt_num(WaterID);

			manufactureID = receiveData.substring(26, 28);
			manufactureID = changePosition(manufactureID);
			System.out.println("厂商ID——————" + manufactureID);
			water.setManufacture_id(manufactureID);
		}

		// 时间
		String dateString = receiveData.substring(28, 42);
		dateString = dateString.substring(0, 4) + "-" + dateString.substring(4, 6) + "-" + dateString.substring(6, 8)
				+ " " + dateString.substring(8, 10) + ":" + dateString.substring(10, 12) + ":"
				+ dateString.substring(12, 14);
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

		Date date = sdf.parse(dateString);
		dateString = sdf.format(date);
		water.setCur_date(dateString);
		
		// 按日
		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd");
		Date date1 = sdf1.parse(dateString);
		String dateString1 = sdf1.format(date1);
		
		// 加一天是上传当前累计流量时间
		// 按小时
//		Calendar c = Calendar.getInstance();
//        c.setTime(sdf.parse(dateString));
//        c.add(Calendar.DAY_OF_MONTH, 1);// 今天+1天
//        Date tomorrow = c.getTime();
//        String upDate = sdf.format(tomorrow);
//		SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd HH");
//		Date date1 = sdf1.parse(upDate);
//		String dateString1 = sdf1.format(date1);
		
		// update by ljf on 2020-01-03上线帧指令,判断指令是否会有发生变化
		String onlineStatus = receiveData.substring(42,44);
		onlineStatus = hex2Binary(onlineStatus);
		System.out.println("上线帧指令-------"+onlineStatus);
		String onlineType = onlineStatus.substring(7,8);
		System.out.println("上线类型---------"+(onlineType.equals("1")?"一天一次":"其他"));
		String moduleType = onlineStatus.substring(4,7);
		System.out.println("模组类型---------"+moduleType);
		String upTem = onlineStatus.substring(3,4);
		System.out.println("是否上报PCI和内部温度---------"+(upTem.equals("1")?"上传":"不上传"));
		String upImei = onlineStatus.substring(2,3);
		System.out.println("是否上报IMEI号---------"+(upImei.equals("1")?"上传":"不上传"));
		String upPre = onlineStatus.substring(1,2);
		System.out.println("是否上报压力值---------"+(upPre.equals("1")?"上传":"不上传"));
		String upOnlineStatus2 = onlineStatus.substring(0,1);
		System.out.println("是否存在上线帧指示2---------"+(upOnlineStatus2.equals("1")?"上传":"不上传"));

		// 电池电压
		String Battery = receiveData.substring(44, 48);
		Battery = changePosition(Battery);
		Battery = hex2Binary(Battery);
		Battery = Integer.valueOf(Battery, 2).toString();
		double voltage = Double.parseDouble(Battery) / 100;
		// 2019-12-06 update by ljf
		water.setVoltage(voltage);
		System.out.println("电池电压————" + voltage + " V");

		// 累计上线成功次数
		String onlineSum = receiveData.substring(48, 52);
		onlineSum = changePosition(onlineSum);
		onlineSum = hex2Binary(onlineSum);
		onlineSum = Integer.valueOf(onlineSum, 2).toString();
		// System.out.println("累计上线成功次数——" + onlineSum);

		// 累计上线失败次数
		String failedSum = receiveData.substring(52, 56);
		failedSum = changePosition(failedSum);
		failedSum = hex2Binary(failedSum);
		failedSum = Integer.valueOf(failedSum, 2).toString();
		// System.out.println("累计上线失败次数——" + failedSum);

		// 状态字
		String stateStr = receiveData.substring(56, 64);
		// System.out.println("状态字————————" + stateStr);
		// update by ljf on 2019-12-24
		// 状态字
		System.out.println("状态字————————" + stateStr);
		System.out.println("状态字1--------------------" + hex2Binary(stateStr.substring(0, 2)));
		System.out.println("状态字1.0：逆流标志                "
				+ (hex2Binary(stateStr.substring(0, 2)).substring(7, 8).equalsIgnoreCase("0") ? "正常" : "逆流"));
		System.out.println("状态字1.1：按键异常标志        "
				+ (hex2Binary(stateStr.substring(0, 2)).substring(6, 7).equalsIgnoreCase("0") ? "正常" : "故障"));
		System.out.println("状态字1.3：存储故障标志        "
				+ (hex2Binary(stateStr.substring(0, 2)).substring(5, 6).equalsIgnoreCase("0") ? "正常" : "故障"));
		System.out.println("状态字2--------------------" + hex2Binary(stateStr.substring(2, 4)));
		System.out.println("状态字2.7：阀门状态                "
				+ (hex2Binary(stateStr.substring(2, 4)).substring(0, 1).equalsIgnoreCase("0") ? "开阀" : "关阀"));
		System.out.println("状态字2.6：阀门异常                "
				+ (hex2Binary(stateStr.substring(2, 4)).substring(1, 2).equalsIgnoreCase("0") ? "正常" : "异常"));
		System.out.println("状态字2.5：流量通讯异常标志 "
				+ (hex2Binary(stateStr.substring(2, 4)).substring(2, 3).equalsIgnoreCase("0") ? "正常" : "异常"));
		System.out.println("状态字3--------------------" + hex2Binary(stateStr.substring(4, 6)));
		System.out.println("状态字3.4：应急按键标志        "
				+ (hex2Binary(stateStr.substring(4, 6)).substring(3, 4).equalsIgnoreCase("0") ? "正常" : "已关阀三天"));
		System.out.println("状态字4-------" + hex2Binary(stateStr.substring(6, 8)));

		water.setContra_flow(Integer.parseInt(hex2Binary(stateStr.substring(0, 2)).substring(7, 8)));
		water.setPush_button(Integer.parseInt(hex2Binary(stateStr.substring(0, 2)).substring(6, 7)));
		water.setStore(Integer.parseInt(hex2Binary(stateStr.substring(0, 2)).substring(5, 6)));
		water.setValve_status(Integer.parseInt(hex2Binary(stateStr.substring(2, 4)).substring(0, 1)));
		water.setValve_unusual(Integer.parseInt(hex2Binary(stateStr.substring(2, 4)).substring(1, 2)));
		water.setCommunication_status(Integer.parseInt(hex2Binary(stateStr.substring(2, 4)).substring(2, 3)));
		water.setSos_key(Integer.parseInt(hex2Binary(stateStr.substring(4, 6)).substring(3, 4)));

		// 软件版本
		String SofewareStr = receiveData.substring(82, 86);
		SofewareStr = changePosition(SofewareStr);
		SofewareStr = hex2Binary(SofewareStr);
		SofewareStr = Integer.valueOf(SofewareStr, 2).toString(); // 主版本
		String SofewareStr1 = receiveData.substring(86, 88);
		SofewareStr1 = hex2Binary(SofewareStr1);
		SofewareStr1 = Integer.valueOf(SofewareStr1, 2).toString(); // 子版本
		// System.out.println("软件主版本——" + SofewareStr + ",软件子版本——" + SofewareStr1);

		// IMSI 号
		String IMSIStr = receiveData.substring(88, 104);
		water.setIMSI(IMSIStr);

		//添加判断是否上传了IMEI号 update by ljf on 2020-01-03
		int j = 0;
		// 判断是否有IMEI号
		if(upImei.equals("1")) {
			String IMEI = receiveData.substring(104, 120);
			System.out.println("IMEI号——————" + IMEI);
			j = 16;
		}
		
		// 当前累计流量
		String totalFlow = receiveData.substring(104+j, 114+j);
		totalFlow = changePosition(totalFlow);
		System.out.println(totalFlow);
		totalFlow = hex2Binary(totalFlow);
		System.out.println(totalFlow);
		totalFlow = Integer.valueOf(totalFlow, 2).toString();
		Double flow = Double.parseDouble(totalFlow)/10;
		System.out.println("当前累计流量————" + flow + " L");
		water.setCur_flow(String.valueOf(flow / 1000));

		// 当前累计逆流量
		String reverseFlow = receiveData.substring(114+j, 124+j);
		reverseFlow = changePosition(reverseFlow);
		reverseFlow = hex2Binary(reverseFlow);
		reverseFlow = Integer.valueOf(reverseFlow, 2).toString();
		Double flow1 = Double.parseDouble(reverseFlow) / 10 / 1000;
		System.out.println("当前累计逆流量————" + flow1 + " 立方");
		water.setReflux_flow(flow1);

		String imei = "";
		water.setIMEI(imei);

		// 房间号
		String house_num = waterService.findHouse(WaterID);
		water.setHouse_num(house_num);
		water.setGrade(0);

		int nowSum = waterService.findResult(WaterID);

		if (nowSum != 0) {
			System.out.println("已存在水表");
			int updateResult = waterService.updateWtNow(water);
			if (updateResult == 1) {
				System.out.println("更新水表成功");
			} else {
				System.out.println("更新水表失败");
			}
		} else {
			// 插入数据库
			int result = waterService.insertWtNowAll(water);
			if (result == 1) {
				System.out.println("新增水表成功");
			} else {
				System.out.println("新增水表失败");
			}
		}
		System.out.println(water.toString());
//		Thread.sleep(500);
//		// update by ljf on 2020-01-03
//		wtHistoryBean.setWt_num(WaterID);
//		wtHistoryBean.setHouse_num(house_num);
//		wtHistoryBean.setIMEI(imei);
//		wtHistoryBean.setIMSI(IMSIStr);
//		wtHistoryBean.setCur_flow(String.valueOf(flow / 1000));
//		wtHistoryBean.setCur_date(dateString1);	// 按天
////		wtHistoryBean.setCur_date(dateString1+":00:00.000"); // 2018-07-01 00 按小时
//		wtHistoryBean.setManufacture_id(manufactureID);
//		wtHistoryBean.setGrade(0);
//
//		System.out.println("水表表号-------------" + WaterID);
//		System.out.println(wtHistoryBean.toString());
//		
//		int a2 = waterHistoryService.checkSame(wtHistoryBean);
//		if (a2 == 1) {
//			System.out.println("历史记录已存在");
//			return_result = "success";
//		} else {
//			int a3 = waterHistoryService.insertAll(wtHistoryBean);
//			if (a3 == 1) {
//				// System.out.println(wtHistoryBean.toString());
//				int a4 = waterHistoryService.checkSame(wtHistoryBean);
//				if (a4 == 1) {
//					System.out.println("历史记录已存在");
//				}
//			} else {
//				return_result = "fail";
//			}
//		}

		// 日结数组
		String dateReport = receiveData.substring(124+j, 126+j);
		dateReport = hex2Binary(dateReport);
		dateReport = Integer.valueOf(dateReport, 2).toString();
		// System.out.println("日结数组数————" + dateReport);

		// 日结数据
		int days = Integer.parseInt(dateReport);

		String dateString2 = dateString1;
		SimpleDateFormat sj = new SimpleDateFormat("yyyy-MM-dd");
		Date d = sj.parse(dateString2);
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(d);
		// calendar.add(Calendar.DATE, -27);
		// update by ljf on 2019-10-16 解决存储数据库出现超出当前报文的时间
		calendar.add(Calendar.DATE, -Integer.parseInt(dateReport));
		dateString2 = sj.format(calendar.getTime());
		long dif;
		Date date2 = new Date();
		// System.out.println("29天前：" + sj.format(calendar.getTime()));
		for (int i = 0; i < days; i++) {
			String dayReport = receiveData.substring((128 + j + i * 10), (128 + j + (i + 1) * 10));
			dayReport = changePosition(dayReport);
			if (dayReport.equals("ffffffffff")) {
				dif = sdf1.parse(dateString2).getTime() + 86400 * 1000; // 加一天
				date2.setTime(dif);
				dateString2 = sdf1.format(date2);
				continue;
			}
			dayReport = hex2Binary(dayReport);
			dayReport = Integer.valueOf(dayReport, 2).toString();
			Double dayflow = Double.parseDouble(dayReport) / 10;

			// 加一天时间
			try {
				dif = sdf1.parse(dateString2).getTime() + 86400 * 1000; // 加一天
				date2.setTime(dif);
				dateString2 = sdf1.format(date2);
				System.out.println("加一天之后： " + i + "、" + dateString2 + "/" + (dayflow / 1000));
				System.out.println("第  " + dateString2 + " 日的数据————" + dayflow + " L");
				wtHistoryBean.setWt_num(WaterID);
				wtHistoryBean.setHouse_num(house_num);
				wtHistoryBean.setIMEI(imei);
				wtHistoryBean.setIMSI(IMSIStr);
				wtHistoryBean.setCur_flow(String.valueOf(dayflow / 1000));
				wtHistoryBean.setCur_date(dateString2); // 2018-07-01
				wtHistoryBean.setManufacture_id(manufactureID);
				wtHistoryBean.setGrade(0);

				System.out.println("水表表号-------------" + WaterID);
//				int a3 = waterHistoryService.insertAll(wtHistoryBean);
//				// int a3 = waterHistoryMapper.insertAll(wtHistoryBean);
//				System.out.println("-----------------" + a3 + "--------------------------");
//				if (a3 == 1) {
//					// session.commit();
//					// System.out.println(wtHistoryBean.toString());
//					// Thread.sleep(5000);
//					int a2 = waterHistoryService.checkSame(wtHistoryBean);
//					System.out.println("-----------------" + a2 + "--------------------------");
//					if (a2 == 1) {
//						// System.out.println(wtHistoryBean.toString());
//						System.out.println("插入历史流水表成功");
//					} else {
//						return_result = "fail";
//					}
//				}
				int a3 = waterHistoryService.checkSame(wtHistoryBean);

				// int a3 = waterHistoryMapper.insertAll(wtHistoryBean);
				System.out.println("-----------------" + a3 + "--------------------------");
				if (a3 == 1) {
					System.out.println("-----------------已存在历史记录--------------------------");
					// session.commit();
					// System.out.println(wtHistoryBean.toString());
					// Thread.sleep(5000);
				} else {
					int a4 = waterHistoryService.insertAll(wtHistoryBean);
					if (a4 == 1) {
						int a21 = waterHistoryService.checkSame(wtHistoryBean);
						System.out.println("-----------------" + a21 + "--------------------------");
						if (a21 == 1) {
							// System.out.println(wtHistoryBean.toString());
							System.out.println("插入历史流水表成功");
						} else {
							return_result = "fail";
						}
					}
				}
			} catch (Exception e) {
				// TODO: handle exception
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
				continue;
			}
		}

		System.out.println("解析成功");
		System.out.println("返回值"+return_result);
		return return_result;
	}

	// 转换位置
	private static String changePosition(String changeStr) {
		StringBuffer s1 = new StringBuffer();
		for (int i = changeStr.length(); i >= 2; i = i - 2) {
			s1 = s1.append(changeStr.substring(i - 2, i));
		}
		return s1.toString();
	}

	// 16进制转换成二进制
	private static String hex2Binary(String string) {
		// TODO Auto-generated method stub
		String s = "";
		for (int i = 0; i < string.length(); i++) {
			s += char2Binary(string.charAt(i));
		}
		return s;
	}

	private static String char2Binary(char charAt) {
		// TODO Auto-generated method stub
		switch (charAt) {
		case '0':
			return "0000";
		case '1':
			return "0001";
		case '2':
			return "0010";
		case '3':
			return "0011";
		case '4':
			return "0100";
		case '5':
			return "0101";
		case '6':
			return "0110";
		case '7':
			return "0111";
		case '8':
			return "1000";
		case '9':
			return "1001";
		case 'a':
			return "1010";
		case 'b':
			return "1011";
		case 'c':
			return "1100";
		case 'd':
			return "1101";
		case 'e':
			return "1110";
		case 'f':
			return "1111";
		case 'A':
			return "1010";
		case 'B':
			return "1011";
		case 'C':
			return "1100";
		case 'D':
			return "1101";
		case 'E':
			return "1110";
		case 'F':
			return "1111";

		}
		return null;
	}

}
