package com.mh.garrison.mhutils;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.text.ParseException;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mh.garrison.entity.DeviceInfo;
import com.mh.garrison.entity.DeviceMessage;
import com.mh.garrison.entity.DevicesBean;


public class FastJsonUtil {
	
		public String analysisFastJson(String receiveData) throws ParseException {
	
		String stateMessage = "fail";
		
		DevicesBean devicesBean = new DevicesBean();
		DeviceMessage deviceMessage = new DeviceMessage();
		DeviceInfo deviceInfo = new DeviceInfo();

		JSONObject jsonObject = JSONObject.parseObject(receiveData);

		// 解析第一层
		devicesBean.setTotalCount(jsonObject.getLongValue("totalCount"));
		devicesBean.setPageNo(jsonObject.getLongValue("pageNo"));
		devicesBean.setPageSize(jsonObject.getLongValue("pageSize"));
		devicesBean.setDevices(jsonObject.getString("devices"));

		// 解析第二层
		JSONArray devices =  jsonObject.getJSONArray("devices");
//		System.out.println("--------------设备使用量------------" + devices.size());
		for (int i = 0; i < devices.size(); i++) {
			
			JSONObject jsonObject2 = devices.getJSONObject(i);
			
			String deviceId = jsonObject2.getString("deviceId");							// 设备ID号
			deviceMessage.setDeviceId(deviceId);
			
			deviceMessage.setGatewayId(jsonObject2.getString("gatewayId"));
			deviceMessage.setNodeType(jsonObject2.getString("nodeType"));
			String createTime = jsonObject2.getString("createTime");						// 设备注册时间
			createTime = TimeUtils.UTCToCST(createTime, "yyyy-MM-dd'T'HH:mm:ss'Z'");
			deviceMessage.setCreateTime(createTime);
			
			String lastModifiedTime = jsonObject2.getString("lastModifiedTime");			// 设备最近连接上来的时间
			lastModifiedTime = TimeUtils.UTCToCST(lastModifiedTime, "yyyy-MM-dd'T'HH:mm:ss'Z'");
			
			deviceMessage.setLastModifiedTime(lastModifiedTime);
			
			deviceMessage.setDeviceInfo(jsonObject2.getString("deviceInfo"));
			deviceMessage.setServices(jsonObject2.getString("services"));
			deviceMessage.setConnectionInfo(jsonObject2.getString("connectionInfo"));
			deviceMessage.setDevGroupIds(jsonObject2.getString("devGroupIds"));
			System.out.println("--------------------------第二层-------------------------");
			System.out.println(deviceMessage.toString());
			
			// 解析第三层
			JSONObject jsonObject3 = JSONObject.parseObject(jsonObject2.getString("deviceInfo"));
			
			String IMEI = jsonObject3.getString("nodeId");									// 设备IMEI号
			deviceInfo.setNodeId(IMEI);
			
			deviceInfo.setName(jsonObject3.getString("name"));
			deviceInfo.setManufactureId(jsonObject3.getString("manufacturerId"));
			deviceInfo.setManufacturerName(jsonObject3.getString("manufacturerName"));
			deviceInfo.setDeviceType(jsonObject3.getString("deviceType"));
			
			String state = jsonObject3.getString("status");									// 设备状态
			deviceInfo.setStatus(state);
			System.out.println("--------------------------第三层-------------------------");
			System.out.println(deviceInfo.toString());
			
//			String address = "jdbc:sqlserver://134.175.248.88:2008;Databasename=NB_SHZLS";
//			String dbuser = "sa";
//			String dbpasswd = "mhtech@803";
//			String database = "NB_SHZLS";
			
			String address = "jdbc:sqlserver://134.175.248.88:2008;Databasename=yjc_jingbeiqu";
			String dbuser = "sa";
			String dbpasswd = "mhtech@803";
			String database = "yjc_jingbeiqu";
			
//			String address = "jdbc:sqlserver://193.112.131.36";
//			String dbuser = "sa";
//			String dbpasswd = "mhtech@803";
//			String database = "yjc_jingbeiqu";
//			String database = "yjc_xinghai_dxc";
			try {
//				System.out.println("计算值>>>>>>>>>>>>>>>>>>>>>>>>>" + i);
				Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver").newInstance();
				Connection con = DriverManager.getConnection(address, dbuser, dbpasswd);
				con.setCatalog(database);
				CallableStatement proc = con.prepareCall("{call pro_add_state(?,?,?,?,?)}");
				proc.setString(1, deviceId);
				proc.setString(2, createTime);
				proc.setString(3, lastModifiedTime);
				proc.setString(4, IMEI);
				proc.setString(5, state);
				proc.execute();
				proc.close();
				con.close();
				stateMessage =  "success";
			} catch (Exception e) {
				// TODO: handle exception
				stateMessage = "fail";
//				String causeStr = e.getCause().getMessage();
//				System.out.println(">>>>>>>-------------" + causeStr);
			}
			
		}
//				JSONObject.parseArray(jsonObject.getString("devices"));
		
//		JSONArray deviceMessageJson = jsonObject.getJSONObject("devices");
//		serviceBean.setServiceId(deviceMessageJson.getString("serviceId"));
//		serviceBean.setServiceType(serviceJson.getString("serviceType"));
//		serviceBean.setDataBean(serviceJson.getString("data"));
//		serviceBean.setEventTime(serviceJson.getString("eventTime"));
//
//		// 解析第三层
//		JSONObject dataJson = serviceJson.getJSONObject("data");
//		dataBean.setMeterId(dataJson.getString("meterId"));
//		dataBean.setOnlineType(dataJson.getString("onlineType"));
//		dataBean.setOnlineCode(dataJson.getString("onlineCode"));

		return stateMessage;
	}
	
//	public static void main(String[] args) throws Exception {
//		String jsonData = "{\r\n" + 
//				"    \"totalCount\":1,\r\n" + 
//				"    \"pageNo\":0,\r\n" + 
//				"    \"pageSize\":10,\r\n" + 
//				"    \"devices\":[\r\n" + 
//				"        {\r\n" + 
//				"            \"deviceId\":\"9e22e475-89a7-4b36-9462-ee61b1000c20\",\r\n" + 
//				"            \"gatewayId\":\"9e22e475-89a7-4b36-9462-ee61b1000c20\",\r\n" + 
//				"            \"nodeType\":\"GATEWAY\",\r\n" + 
//				"            \"createTime\":\"20181013T062538Z\",\r\n" + 
//				"            \"lastModifiedTime\":\"20181013T070436Z\",\r\n" + 
//				"            \"deviceInfo\":{\r\n" + 
//				"                \"nodeId\":\"865352033012310\",\r\n" + 
//				"                \"name\":\"865352033012310\",\r\n" + 
//				"                \"description\":null,\r\n" + 
//				"                \"manufacturerId\":\"MH\",\r\n" + 
//				"                \"manufacturerName\":\"MH\",\r\n" + 
//				"                \"mac\":null,\r\n" + 
//				"                \"location\":\"Shenzhen\",\r\n" + 
//				"                \"deviceType\":\"MHMeter\",\r\n" + 
//				"                \"model\":\"DDS3666\",\r\n" + 
//				"                \"swVersion\":null,\r\n" + 
//				"                \"fwVersion\":\"Neul@Hi12RM0-B5@B657R5Lierda1200104,V100R100C10B657SP5,V100R100C10B657SP5@5\",\r\n" + 
//				"                \"hwVersion\":null,\r\n" + 
//				"                \"protocolType\":\"CoAP\",\r\n" + 
//				"                \"bridgeId\":null,\r\n" + 
//				"                \"status\":\"ONLINE\",\r\n" + 
//				"                \"statusDetail\":\"NONE\",\r\n" + 
//				"                \"mute\":\"FALSE\",\r\n" + 
//				"                \"supportedSecurity\":null,\r\n" + 
//				"                \"isSecurity\":null,\r\n" + 
//				"                \"signalStrength\":null,\r\n" + 
//				"                \"sigVersion\":null,\r\n" + 
//				"                \"serialNumber\":null,\r\n" + 
//				"                \"batteryLevel\":null\r\n" + 
//				"            },\r\n" + 
//				"            \"services\":[\r\n" + 
//				"                {\r\n" + 
//				"                    \"serviceId\":\"Connectivity\",\r\n" + 
//				"                    \"serviceType\":\"Connectivity\",\r\n" + 
//				"                    \"data\":{\r\n" + 
//				"                        \"signalStrength\":0,\r\n" + 
//				"                        \"linkQuality\":0,\r\n" + 
//				"                        \"cellId\":0\r\n" + 
//				"                    },\r\n" + 
//				"                    \"eventTime\":\"20181013T070436Z\",\r\n" + 
//				"                    \"serviceInfo\":null\r\n" + 
//				"                },\r\n" + 
//				"                {\r\n" + 
//				"                    \"serviceId\":\"MHMeterData\",\r\n" + 
//				"                    \"serviceType\":\"MHMeterData\",\r\n" + 
//				"                    \"data\":{\r\n" + 
//				"                        \"MHMeterData\":\"68000000000000688118323236333333ca5633333333333333433583334b343333336716\"\r\n" + 
//				"                    },\r\n" + 
//				"                    \"eventTime\":\"20181013T070436Z\",\r\n" + 
//				"                    \"serviceInfo\":null\r\n" + 
//				"                }\r\n" + 
//				"            ],\r\n" + 
//				"            \"connectionInfo\":{\r\n" + 
//				"                \"cellId\":\"******\"\r\n" + 
//				"            },\r\n" + 
//				"            \"devGroupIds\":[\r\n" + 
//				"\r\n" + 
//				"            ]\r\n" + 
//				"        }\r\n" + 
//				"    ]\r\n" + 
//				"}";
//		FastJsonUtil fastJson = new FastJsonUtil();
//		String string = fastJson.analysisFastJson(jsonData);
//		System.out.println(string);
//		
//	}

}
