package com.mh.garrison.mhutils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.context.ApplicationContext;

import com.mh.garrison.entity.MeterHistoryBean;
import com.mh.garrison.entity.MeterNowBean;
import com.mh.garrison.entity.ThreeMeterNowBean;
import com.mh.garrison.mapper.DeviceMapper;
import com.mh.garrison.mapper.MeterHistoryMapper;
import com.mh.garrison.mapper.MeterNowMapper;
import com.mh.garrison.service.DeviceService;
import com.mh.garrison.service.MeterHistoryService;
import com.mh.garrison.service.MeterNowService;

public class MeterUtils {

	// 添加之后能够对mapper调用
	public ApplicationContext applicationContext = SpringUtils.getApplicationContext();
	
	public MeterNowService meterNowService = applicationContext.getBean(MeterNowService.class);
	public MeterHistoryService meterHistoryService = applicationContext.getBean(MeterHistoryService.class);
	
	public MeterNowMapper meterNowMapper = applicationContext.getBean(MeterNowMapper.class);
	public MeterHistoryMapper meterHistoryMapper = applicationContext.getBean(MeterHistoryMapper.class);

	// 添加之后能够对mapper调用
	public DeviceMapper deviceMapper = applicationContext.getBean(DeviceMapper.class);
	public DeviceService deviceService = applicationContext.getBean(DeviceService.class);

	/**
	 * 校验和
	 * 
	 * @param data
	 * @return
	 */
	private static String makeChecksum(String data) {
		if (data == null || data.equals("")) {
			return "";
		}
		int total = 0;
		int len = data.length();
		int num = 0;
		while (num < len) {
			String s = data.substring(num, num + 2);
			// System.out.println(s);
			total += Integer.parseInt(s, 16);
			num = num + 2;
		}
		/**
		 * 用256求余最大是255，即16进制的FF
		 */
		int mod = total % 256;
		String hex = Integer.toHexString(mod);
		len = hex.length();
		// 如果不够校验位的长度，补0,这里用的是两位校验
		if (len < 2) {
			hex = "0" + hex;
		}
		return hex;
	}

	/**
	 * 转换位置
	 * 
	 * @param data
	 * @return
	 */
	private static String changePosition(String data) {
		String newData = "";
		for (int i = data.length() / 2; i > 0; i--) {
			newData = newData + data.substring(2 * i - 2, 2 * i);
			// System.out.println(newData);
		}
		return newData;
	}

	/**
	 * 减33操作
	 * 
	 * @param data
	 * @return
	 */
	private static String minusThree(String data) {
		int b = Integer.parseInt("33", 16); // 33值
		String newData = ""; // 新返回值
		for (int i = 0; i < data.length() / 2; i++) {
			String cutString = data.substring(2 * i, 2 * i + 2);
			// System.out.println("截取的字符——" + cutString);
			int a1 = Integer.parseInt(cutString, 16);
			int b1 = a1 - b;
			if (b1 < 0) {
				System.out.println("数据格式有误");
				return "数据格式有误";
			} else {
				b1 = b1 % 256;
				String hexString = Integer.toHexString(b1);
				if (hexString.length() < 2) {
					hexString = "0" + hexString;
					// System.out.println(hexString);
					newData = newData + hexString;
				} else {
					newData = newData + hexString;
				}
			}
		}
		return newData;
	}

	public String analysisSendOrder(String data) {

		// 68563412000000688400F016
		String state = "fail";
		int len = data.length();

		// 校验和
		String checkSum = MeterUtils.makeChecksum(data.substring(0, len - 4));
		System.out.println("计算后校验和    " + checkSum);

		// 比较校验和
		String check = data.substring(len - 4, len - 2);
		System.out.println("计算前校验和    " + check);

		if (checkSum.equals(check)) {
			System.out.println("校验和对比正常");

			// 表号
			String meterID = data.substring(2, 14);
			meterID = MeterUtils.changePosition(meterID);
			System.out.println("表号    " + meterID);

			String passBack = data.substring(16, 20);
			if (passBack.equals("8400")) {
				Map<String, Object> params = new HashMap<>();
				params.put("device_num", meterID);
				params.put("remark", "命令");
				List<Map<String, Object>> list = deviceService.exeProcedure(params);
				for (Map<String, Object> map : list) {
					System.out.println(map);
				}
				Object result = params.get("state");
				if (result.equals("没有命令待发") || result.equals("已发送")) {
					state = "success";
				}
			} else {
				state = "fail";
			}
		}

		return state;

	}

	public String analysisAEPMeter(String data, String eventTime, String deviceId, String imei) {

		MeterNowBean meterNowBean = new MeterNowBean();
		MeterHistoryBean meterHistoryBean = new MeterHistoryBean();

		int len = data.length();

		// 校验和
		String checkSum = MeterUtils.makeChecksum(data.substring(0, len - 4));
		System.out.println("计算后校验和    " + checkSum);

		// 比较校验和
		String check = data.substring(len - 4, len - 2);
		System.out.println("计算前校验和    " + check);

		if (checkSum.equals(check)) {
			System.out.println("校验和对比正常");
			// 表号
			String meterID = data.substring(2, 14);
			meterID = MeterUtils.changePosition(meterID);
			System.out.println("表号    " + meterID);

			// 电量
			String meterValue = data.substring(24, 32);
			// System.out.println(meterValue);
			meterValue = MeterUtils.changePosition(meterValue);
			meterValue = MeterUtils.minusThree(meterValue);
			meterValue = meterValue.substring(0, 6) + "." + meterValue.substring(6, meterValue.length());
			System.out.println("电量    " + meterValue);

			// 电压
			String voltage = data.substring(32, 36);
			// System.out.println(voltage);
			voltage = MeterUtils.changePosition(voltage);
			voltage = MeterUtils.minusThree(voltage);
			voltage = voltage.substring(0, 3) + "." + voltage.substring(3, 4);
			System.out.println("电压    " + voltage);

			// 电流
			String current = data.substring(36, 42);
			// System.out.println(current);
			current = MeterUtils.changePosition(current);
			current = MeterUtils.minusThree(current);
			current = current.substring(0, 3) + "." + current.substring(3, current.length());
			System.out.println("电流    " + current);

			// 功率
			String power = data.substring(42, 48);
			// System.out.println(power);
			power = MeterUtils.changePosition(power);
			power = MeterUtils.minusThree(power);
			power = power.substring(0, 2) + "." + power.substring(2, power.length());
			System.out.println("功率    " + power);

			// 功率因数
			String powerFactor = data.substring(48, 52);
			// System.out.println(powerFactor);
			powerFactor = MeterUtils.changePosition(powerFactor);
			powerFactor = MeterUtils.minusThree(powerFactor);
			powerFactor = powerFactor.substring(0, 1) + "." + powerFactor.substring(1, powerFactor.length());
			System.out.println("功率因数" + powerFactor);

			// 频率
			String frequency = data.substring(52, 56);
			// System.out.println(frequency);
			frequency = MeterUtils.changePosition(frequency);
			frequency = MeterUtils.minusThree(frequency);
			frequency = frequency.substring(0, 2) + "." + frequency.substring(2, frequency.length());
			System.out.println("频率    " + frequency);

			// 状态
			String state = data.substring(56, 58);
			// System.out.println(state);
			state = MeterUtils.changePosition(state);
			state = MeterUtils.minusThree(state);
			Integer num = Integer.parseInt(state, 16);
			if (num == 0) {
				state = "合闸";
			} else if (num == 1) {
				state = "拉闸";
			} else if (num == 2) {
				state = "合闸，功率超限";
			} else if (num == 3) {
				state = "拉闸，功率超限";
			}
			// if (state.equals("00")) {
			// state = "合闸";
			// } else if (state.equals("01")) {
			// state = "拉闸";
			// }
			System.out.println("状态    " + state);

			// 网络信号
			String netSignal = data.substring(58, 60);
			// System.out.println(netSignal);
			netSignal = MeterUtils.changePosition(netSignal);
			netSignal = MeterUtils.minusThree(netSignal);
			System.out.println("网络信号" + netSignal);

			// 定时上传时间
			String timeUpload = data.substring(60, 64);
			// System.out.println(timeUpload);
			timeUpload = MeterUtils.changePosition(timeUpload);
			timeUpload = MeterUtils.minusThree(timeUpload);
			System.out.println("定时上传时间" + timeUpload);

			// 限容功率
			String spare = data.substring(64, 68);
			// System.out.println(spare);
			spare = MeterUtils.changePosition(spare);
			spare = MeterUtils.minusThree(spare);
			spare = spare.substring(0, 2) + "." + spare.substring(2, spare.length());
			System.out.println("限容功率    " + spare);

			// 查询基表安装表是否是对应的平台
			Integer platform = deviceService.findPlatform(meterID);
			if (platform == null || platform == 0 ) {
				// 更新变成AEP平台
				deviceService.updatePlatform(meterID);
			}
			// 插入表状态
			Map<String, Object> maps = new HashMap<>();
			maps.put("device_id", deviceId);
			maps.put("create_date", eventTime);
			maps.put("lastModifiedTime", eventTime);
			maps.put("device_imei", imei);
			maps.put("device_state", "ONLINE");
			deviceService.exeAddStateProcedure(maps);

			// 房间号
			String house_num = null;

			// 楼栋
			String building_name = null;
			try {
				house_num = meterNowService.findHouse(meterID);
//				Thread.sleep(200);
				building_name = meterNowService.findBuildingName(meterID);
				// building_name = meterNowMapper.findBuilding(house_num);// 查询楼层
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
//				house_num = "";
//				building_name = "";
			}

			meterNowBean.setMt_num(meterID);
			meterNowBean.setMt_electric(meterValue);
			meterNowBean.setMt_state(state);
			meterNowBean.setMt_device_id(deviceId);
			meterNowBean.setMt_time(eventTime);
			meterNowBean.setLimited_power(spare);
			meterNowBean.setHouse_num(house_num);
			meterNowBean.setBuilding_name(building_name);
			meterNowBean.setGrade(0);

			try {

				if (meterNowService.checkMeterId(meterNowBean) != 0) {
					meterNowService.updateAll(meterNowBean);
					System.out.println("-----------更新实时表成功-----------");
					// meterNowMapper.exePro_calc_Meter(); // 开始计算电表数据
				} else {
					meterNowService.insertAll(meterNowBean);
					System.out.println("-----------插入实时表成功-----------");
					// meterNowMapper.exePro_calc_Meter(); // 开始计算电表数据
				}

				// 插入到历史流水表中
				meterHistoryBean.setMt_num(meterID);
				meterHistoryBean.setMt_electric(meterValue);
				meterHistoryBean.setMt_state(state);
				meterHistoryBean.setMt_device_id(deviceId);
				meterHistoryBean.setMt_time(eventTime);
				meterHistoryBean.setHouse_num(house_num);
				meterHistoryBean.setBuilding_name(building_name);
				meterHistoryBean.setGrade(0);
//				Thread.sleep(300);
				int b = meterHistoryService.insertAll(meterHistoryBean);
				if (b == 1) {
					System.out.println(meterHistoryBean.toString());
//					Thread.sleep(500);
				} else {
					System.out.println("-----------插入历史表失败-----------");
				}
				int c = meterHistoryService.checkHistory(meterHistoryBean);
				if (c != 0) {
					//防止是否存在数据库内，继续查询对应的数据，如果存在则返回成功，不存在返回失败
					System.out.println("-----------插入历史表成功-----------");	
				} else {
					System.out.println("-----------插入历史表失败-----------");
					return "fail";
				}
//				Thread.sleep(300);
			} catch (Exception e) {
				// TODO: handle exception
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
				boolean status = causeStr.contains("违反了 UNIQUE KEY 约束");
				if (status) {
					return "success";
				}
				return "fail";
			}
			// 更新发送命令状态表
			Map<String, Object> params = new HashMap<>();
			params.put("device_num", meterID);
			params.put("remark", "读取数据状态");
			List<Map<String, Object>> list = deviceService.exeProcedure(params);
			for (Map<String, Object> map : list) {
				System.out.println(map.get("state").toString());
			}
			Object result = params.get("state");
			String state1 = null;
			if (result.equals("没有命令待发") || result.equals("已发送")) {
				state1 = "success";
			}
			return state1;
		} else {
			System.out.println("校验和对比错误");
			return "fail";
		}
	}

	public String analysisMeter(String data, String eventTime, String deviceId) {

		MeterNowBean meterNowBean = new MeterNowBean();
		MeterHistoryBean meterHistoryBean = new MeterHistoryBean();

		int len = data.length();

		// 校验和
		String checkSum = MeterUtils.makeChecksum(data.substring(0, len - 4));
		System.out.println("计算后校验和    " + checkSum);

		// 比较校验和
		String check = data.substring(len - 4, len - 2);
		System.out.println("计算前校验和    " + check);

		if (checkSum.equals(check)) {
			System.out.println("校验和对比正常");
			// 表号
			String meterID = data.substring(2, 14);
			meterID = MeterUtils.changePosition(meterID);
			System.out.println("表号    " + meterID);

			// 电量
			String meterValue = data.substring(24, 32);
			// System.out.println(meterValue);
			meterValue = MeterUtils.changePosition(meterValue);
			meterValue = MeterUtils.minusThree(meterValue);
			meterValue = meterValue.substring(0, 6) + "." + meterValue.substring(6, meterValue.length());
			System.out.println("电量    " + meterValue);

			// 电压
			String voltage = data.substring(32, 36);
			// System.out.println(voltage);
			voltage = MeterUtils.changePosition(voltage);
			voltage = MeterUtils.minusThree(voltage);
			voltage = voltage.substring(0, 3) + "." + voltage.substring(3, 4);
			System.out.println("电压    " + voltage);

			// 电流
			String current = data.substring(36, 42);
			// System.out.println(current);
			current = MeterUtils.changePosition(current);
			current = MeterUtils.minusThree(current);
			current = current.substring(0, 3) + "." + current.substring(3, current.length());
			System.out.println("电流    " + current);

			// 功率
			String power = data.substring(42, 48);
			// System.out.println(power);
			power = MeterUtils.changePosition(power);
			power = MeterUtils.minusThree(power);
			power = power.substring(0, 2) + "." + power.substring(2, power.length());
			System.out.println("功率    " + power);

			// 功率因数
			String powerFactor = data.substring(48, 52);
			// System.out.println(powerFactor);
			powerFactor = MeterUtils.changePosition(powerFactor);
			powerFactor = MeterUtils.minusThree(powerFactor);
			powerFactor = powerFactor.substring(0, 1) + "." + powerFactor.substring(1, powerFactor.length());
			System.out.println("功率因数" + powerFactor);

			// 频率
			String frequency = data.substring(52, 56);
			// System.out.println(frequency);
			frequency = MeterUtils.changePosition(frequency);
			frequency = MeterUtils.minusThree(frequency);
			frequency = frequency.substring(0, 2) + "." + frequency.substring(2, frequency.length());
			System.out.println("频率    " + frequency);

			// 状态
			String state = data.substring(56, 58);
			// System.out.println(state);
			state = MeterUtils.changePosition(state);
			state = MeterUtils.minusThree(state);
			Integer num = Integer.parseInt(state, 16);
			if (num == 0) {
				state = "合闸";
			} else if (num == 1) {
				state = "拉闸";
			} else if (num == 2) {
				state = "合闸，功率超限";
			} else if (num == 3) {
				state = "拉闸，功率超限";
			}
			// if (state.equals("00")) {
			// state = "合闸";
			// } else if (state.equals("01")) {
			// state = "拉闸";
			// }
			System.out.println("状态    " + state);

			// 网络信号
			String netSignal = data.substring(58, 60);
			// System.out.println(netSignal);
			netSignal = MeterUtils.changePosition(netSignal);
			netSignal = MeterUtils.minusThree(netSignal);
			System.out.println("网络信号" + netSignal);

			// 定时上传时间
			String timeUpload = data.substring(60, 64);
			// System.out.println(timeUpload);
			timeUpload = MeterUtils.changePosition(timeUpload);
			timeUpload = MeterUtils.minusThree(timeUpload);
			System.out.println("定时上传时间" + timeUpload);

			// 限容功率
			String spare = data.substring(64, 68);
			// System.out.println(spare);
			spare = MeterUtils.changePosition(spare);
			spare = MeterUtils.minusThree(spare);
			spare = spare.substring(0, 2) + "." + spare.substring(2, spare.length());
			System.out.println("限容功率    " + spare);

			// 房间号
			String house_num = null;

			// 楼栋
			String building_name = null;
			try {
				house_num = meterNowService.findHouse(meterID);
//				Thread.sleep(200);
				building_name = meterNowService.findBuildingName(meterID);
				// building_name = meterNowMapper.findBuilding(house_num);// 查询楼层
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
//				house_num = "";
//				building_name = "";
			}

			meterNowBean.setMt_num(meterID);
			meterNowBean.setMt_electric(meterValue);
			meterNowBean.setMt_state(state);
			meterNowBean.setMt_device_id(deviceId);
			meterNowBean.setMt_time(eventTime);
			meterNowBean.setLimited_power(spare);
			meterNowBean.setHouse_num(house_num);
			meterNowBean.setBuilding_name(building_name);
			meterNowBean.setGrade(0);

			try {

				if (meterNowService.checkMeterId(meterNowBean) != 0) {
					meterNowService.updateAll(meterNowBean);
					System.out.println("-----------更新实时表成功-----------");
					// meterNowMapper.exePro_calc_Meter(); // 开始计算电表数据
				} else {
					meterNowService.insertAll(meterNowBean);
					System.out.println("-----------插入实时表成功-----------");
					// meterNowMapper.exePro_calc_Meter(); // 开始计算电表数据
				}

				// 插入到历史流水表中
				meterHistoryBean.setMt_num(meterID);
				meterHistoryBean.setMt_electric(meterValue);
				meterHistoryBean.setMt_state(state);
				meterHistoryBean.setMt_device_id(deviceId);
				meterHistoryBean.setMt_time(eventTime);
				meterHistoryBean.setHouse_num(house_num);
				meterHistoryBean.setBuilding_name(building_name);
				meterHistoryBean.setGrade(0);
//				Thread.sleep(300);
				int b = meterHistoryService.insertAll(meterHistoryBean);
				if (b == 1) {
					System.out.println(meterHistoryBean.toString());
//					Thread.sleep(500);
				} else {
					System.out.println("-----------插入历史表失败-----------");
				}
				int c = meterHistoryService.checkHistory(meterHistoryBean);
				if (c != 0) {
					//防止是否存在数据库内，继续查询对应的数据，如果存在则返回成功，不存在返回失败
					System.out.println("-----------插入历史表成功-----------");
				} else {
					System.out.println("-----------插入历史表失败-----------");
					return "fail";
				}
//				Thread.sleep(300);
			} catch (Exception e) {
				// TODO: handle exception
				String causeStr = e.getCause().getMessage();
				System.out.println(">>>>>>>-------------" + causeStr);
				boolean status = causeStr.contains("违反了 UNIQUE KEY 约束");
				if (status) {
					return "success";
				}
				return "fail";
			}
			// 更新发送命令状态表
			Map<String, Object> params = new HashMap<>();
			params.put("device_num", meterID);
			params.put("remark", "读取数据状态");
			List<Map<String, Object>> list = deviceService.exeProcedure(params);
			for (Map<String, Object> map : list) {
				System.out.println(map.get("state").toString());
			}
			Object result = params.get("state");
			String state1 = null;
			if (result.equals("没有命令待发") || result.equals("已发送")) {
				state1 = "success";
			}
			return state1;
		} else {
			System.out.println("校验和对比错误");
			return "fail";
		}
	}

	public String analysisThreeMeter(String threeMeterStr, String eventTime, String device_id) {

		ThreeMeterNowBean threeMeterNowBean = new ThreeMeterNowBean();
		MeterHistoryBean meterHistoryBean = new MeterHistoryBean();

		int len = threeMeterStr.length();

		System.out.println("三相电表数据报文长度----------" + len);

		// 计算的检验和
		String checkSum = MeterUtils.makeChecksum(threeMeterStr.substring(0, len - 4));
		System.out.println("计算后的校验和----" + checkSum);

		// 数据本身的校验和
		String check = threeMeterStr.substring(len - 4, len - 2);
		System.out.println("计算前的校验和----" + check);

		System.out.println(checkSum.equalsIgnoreCase(check));
		// 比较校验和
		if (checkSum.equalsIgnoreCase(check)) {

			System.out.println("检验和正常");

			// 表号
			String meterID = threeMeterStr.substring(2, 14);
			meterID = MeterUtils.changePosition(meterID);
			System.out.println("表号----------" + meterID);

			// 电量
			String meterValue = threeMeterStr.substring(24, 32);
			meterValue = MeterUtils.changePosition(meterValue);
			meterValue = MeterUtils.minusThree(meterValue);
			meterValue = meterValue.substring(0, 6) + "." + meterValue.substring(6, meterValue.length());
			System.out.println("电量    " + meterValue);

			// 电压A
			String voltage_a = threeMeterStr.substring(32, 36);
			// System.out.println(voltage);
			voltage_a = MeterUtils.changePosition(voltage_a);
			voltage_a = MeterUtils.minusThree(voltage_a);
			voltage_a = voltage_a.substring(0, 3) + "." + voltage_a.substring(3, 4);
			System.out.println("电压 A   " + voltage_a);

			// 电压B
			String voltage_b = threeMeterStr.substring(34, 40);
			// System.out.println(voltage);
			voltage_b = MeterUtils.changePosition(voltage_b);
			voltage_b = MeterUtils.minusThree(voltage_b);
			voltage_b = voltage_b.substring(0, 3) + "." + voltage_b.substring(3, 4);
			System.out.println("电压 B   " + voltage_b);

			// 电压C
			String voltage_c = threeMeterStr.substring(40, 44);
			// System.out.println(voltage);
			voltage_c = MeterUtils.changePosition(voltage_c);
			voltage_c = MeterUtils.minusThree(voltage_c);
			voltage_c = voltage_c.substring(0, 3) + "." + voltage_c.substring(3, 4);
			System.out.println("电压 C   " + voltage_c);

			// 电流A
			String current_a = threeMeterStr.substring(44, 50);
			// System.out.println(current);
			current_a = MeterUtils.changePosition(current_a);
			current_a = MeterUtils.minusThree(current_a);
			current_a = current_a.substring(0, 3) + "." + current_a.substring(3, current_a.length());
			System.out.println("电流A    " + current_a);

			// 电流B
			String current_b = threeMeterStr.substring(50, 56);
			// System.out.println(current);
			current_b = MeterUtils.changePosition(current_b);
			current_b = MeterUtils.minusThree(current_b);
			current_b = current_b.substring(0, 3) + "." + current_b.substring(3, current_b.length());
			System.out.println("电流B    " + current_b);

			// 电流C
			String current_c = threeMeterStr.substring(56, 62);
			// System.out.println(current);
			current_c = MeterUtils.changePosition(current_c);
			current_c = MeterUtils.minusThree(current_c);
			current_c = current_c.substring(0, 3) + "." + current_c.substring(3, current_c.length());
			System.out.println("电流C    " + current_c);

			// 功率总
			String power_total = threeMeterStr.substring(62, 68);
			// System.out.println(power);
			power_total = MeterUtils.changePosition(power_total);
			power_total = MeterUtils.minusThree(power_total);
			power_total = power_total.substring(0, 2) + "." + power_total.substring(2, power_total.length());
			System.out.println("功率总   " + power_total);

			// 功率a
			String power_a = threeMeterStr.substring(68, 74);
			// System.out.println(power);
			power_a = MeterUtils.changePosition(power_a);
			power_a = MeterUtils.minusThree(power_a);
			power_a = power_a.substring(0, 2) + "." + power_a.substring(2, power_a.length());
			System.out.println("功率A   " + power_a);

			// 功率B
			String power_b = threeMeterStr.substring(74, 80);
			// System.out.println(power);
			power_b = MeterUtils.changePosition(power_b);
			power_b = MeterUtils.minusThree(power_b);
			power_b = power_b.substring(0, 2) + "." + power_b.substring(2, power_b.length());
			System.out.println("功率B   " + power_b);

			// 功率C
			String power_c = threeMeterStr.substring(80, 86);
			// System.out.println(power);
			power_c = MeterUtils.changePosition(power_c);
			power_c = MeterUtils.minusThree(power_c);
			power_c = power_c.substring(0, 2) + "." + power_c.substring(2, power_c.length());
			System.out.println("功率C   " + power_c);

			// 功率因数总
			String powerFactor_total = threeMeterStr.substring(86, 90);
			// System.out.println(powerFactor);
			powerFactor_total = MeterUtils.changePosition(powerFactor_total);
			powerFactor_total = MeterUtils.minusThree(powerFactor_total);
			powerFactor_total = powerFactor_total.substring(0, 1) + "."
					+ powerFactor_total.substring(1, powerFactor_total.length());
			System.out.println("功率因数总		" + powerFactor_total);

			// 功率因数A
			String powerFactor_a = threeMeterStr.substring(90, 94);
			// System.out.println(powerFactor);
			powerFactor_a = MeterUtils.changePosition(powerFactor_a);
			powerFactor_a = MeterUtils.minusThree(powerFactor_a);
			powerFactor_a = powerFactor_a.substring(0, 1) + "." + powerFactor_a.substring(1, powerFactor_a.length());
			System.out.println("功率因数A		" + powerFactor_a);

			// 功率因数B
			String powerFactor_b = threeMeterStr.substring(94, 98);
			// System.out.println(powerFactor);
			powerFactor_b = MeterUtils.changePosition(powerFactor_b);
			powerFactor_b = MeterUtils.minusThree(powerFactor_b);
			powerFactor_b = powerFactor_b.substring(0, 1) + "." + powerFactor_b.substring(1, powerFactor_b.length());
			System.out.println("功率因数B		" + powerFactor_b);

			// 功率因数C
			String powerFactor_c = threeMeterStr.substring(98, 102);
			// System.out.println(powerFactor);
			powerFactor_c = MeterUtils.changePosition(powerFactor_c);
			powerFactor_c = MeterUtils.minusThree(powerFactor_c);
			powerFactor_c = powerFactor_c.substring(0, 1) + "." + powerFactor_c.substring(1, powerFactor_c.length());
			System.out.println("功率因数C		" + powerFactor_c);

			// 频率
			String frequency = threeMeterStr.substring(102, 106);
			// System.out.println(frequency);
			frequency = MeterUtils.changePosition(frequency);
			frequency = MeterUtils.minusThree(frequency);
			frequency = frequency.substring(0, 2) + "." + frequency.substring(2, frequency.length());
			System.out.println("频率    " + frequency);

			// 状态
			String state = threeMeterStr.substring(106, 108);
			// System.out.println(state);
			state = MeterUtils.changePosition(state);
			state = MeterUtils.minusThree(state);
			Integer num = Integer.parseInt(state, 16);
			if (num == 0) {
				state = "合闸";
			} else if (num == 1) {
				state = "拉闸";
			} else if (num == 2) {
				state = "合闸，功率超限";
			} else if (num == 3) {
				state = "拉闸，功率超限";
			}
			System.out.println("状态    " + state);

			// 网络信号
			String netSignal = threeMeterStr.substring(108, 110);
			// System.out.println(netSignal);
			netSignal = MeterUtils.changePosition(netSignal);
			netSignal = MeterUtils.minusThree(netSignal);
			System.out.println("网络信号	" + netSignal);

			// 定时上传时间
			String timeUpload = threeMeterStr.substring(110, 114);
			// System.out.println(timeUpload);
			timeUpload = MeterUtils.changePosition(timeUpload);
			timeUpload = MeterUtils.minusThree(timeUpload);
			System.out.println("定时上传时间	" + timeUpload);

			// 限容功率
			String limited_power = threeMeterStr.substring(114, 118);
			// System.out.println(timeUpload);
			limited_power = MeterUtils.changePosition(limited_power);
			limited_power = MeterUtils.minusThree(limited_power);
			limited_power = limited_power.substring(0, 2) + "." + limited_power.substring(2, limited_power.length());
			System.out.println("限容功率	" + limited_power);

			// 备用
			String spare = threeMeterStr.substring(118, 122);
			// System.out.println(spare);
			spare = MeterUtils.changePosition(spare);
			spare = MeterUtils.minusThree(spare);
			System.out.println("备用    " + spare);
			try {
				// 如果是厦门双桥三相电表
				// 房间号
				String house_num = meterNowService.findHouse1(meterID);
				System.out.println("房间号："+house_num);
				Thread.sleep(200);
//				 楼栋
//				String building_name = meterNowMapper.findBuilding(house_num); // 楼层
				String building_name = meterNowService.findBuildingName1(meterID);
				System.out.println("楼栋："+building_name);
				
//				// 房间号
//				String house_num = meterNowService.findHouse(meterID);
////				Thread.sleep(200);
//				// 楼栋
////				 String building_name = meterNowMapper.findBuilding(house_num); // 楼层
//				String building_name = meterNowService.findBuildingName(meterID);
//				if (building_name == null) {
//					building_name = meterNowService.findBuildingName(meterID);
//				} 
				

				threeMeterNowBean.setMt_num(meterID);
				threeMeterNowBean.setMt_electric(Double.parseDouble(meterValue));
				threeMeterNowBean.setMt_state(state);
				threeMeterNowBean.setMt_device_id(device_id);
				threeMeterNowBean.setMt_time(eventTime);
				threeMeterNowBean.setLimited_power(limited_power);
				threeMeterNowBean.setHouse_num(house_num);
				threeMeterNowBean.setBuilding_name(building_name);
				threeMeterNowBean.setGrade(0);

				// 插入到历史流水表中
				meterHistoryBean.setMt_num(meterID);
				meterHistoryBean.setMt_electric(meterValue);
				meterHistoryBean.setMt_state(state);
				meterHistoryBean.setMt_device_id(device_id);
				meterHistoryBean.setMt_time(eventTime);
				meterHistoryBean.setHouse_num(house_num);
				meterHistoryBean.setBuilding_name(building_name);
				meterHistoryBean.setGrade(0);

//				Thread.sleep(300);
				// 直接插入数据库
				int his = meterHistoryService.insertAll(meterHistoryBean);
				if (his == 1) {
					// System.out.println(meterHistoryBean.toString());
					//防止是否存在数据库内，继续查询对应的数据，如果存在则返回成功，不存在返回失败
					int c = meterHistoryService.checkHistory(meterHistoryBean);
					if (c != 0) {
						System.out.println("-----------插入历史表成功-----------");	
					} else {
						System.out.println("-----------插入历史表失败-----------");
						return "fail";
					}
				} else {
					System.out.println("-----------插入历史表失败-----------");
				}
				
//				Thread.sleep(300);
				if (meterNowService.checkMeterId(threeMeterNowBean) != 0) {
					meterNowService.updateAll(threeMeterNowBean);

					// meterNowMapper.exePro_calc_Meter(); // 开始计算电表数据
				} else {
					meterNowService.insertAll(threeMeterNowBean);

					// meterNowMapper.exePro_calc_Meter(); // 开始计算电表数据
				}

				

//				Thread.sleep(300);
				
			} catch (Exception e) {
				// TODO: handle exception
				String causeStr = e.getCause().getMessage(); 
				System.out.println(causeStr);
				boolean status = causeStr.contains("违反了 UNIQUE KEY 约束");
				if (status) {
					return "success";
				}
				return "fail";
			}
			// 更新发送命令状态表
			Map<String, Object> params = new HashMap<>();
			params.put("device_num", meterID);
			params.put("remark", "读取数据状态");
			List<Map<String, Object>> list = deviceMapper.exeProcedure(params);
			for (Map<String, Object> map : list) {
				System.out.println(map.get("state").toString());
			}
			Object result = params.get("state");
			String state1 = null;
			if (result.equals("没有命令待发") || result.equals("已发送")) {
				state1 = "success";
			}
			return state1;
		} else {
			System.out.println("校验和对比错误");
			return "fail";
		}
	}

	public static void main(String[] args) {
		// 68000205080000688118323237333333b554333333333333334335833433333333334816

		String string = "689603019000006881333232b87953333656c855c4553a4b333a4b333a4b33c34434366b33b76933346a33453c463c3b3c473cca7c34336f3333333333fe16";

		MeterUtils meterUtils = new MeterUtils();

		// String result = meterUtils.analysisSendOrder(string);
		String result = meterUtils.analysisThreeMeter(string, "", "");

		System.out.println(result);

	}

}
