package com.mh.garrison.mhutils;

import com.alibaba.fastjson.JSONObject;
import com.ctg.ag.sdk.biz.AepDeviceCommandLwmProfileClient;
import com.ctg.ag.sdk.biz.aep_device_command_lwm_profile.CreateCommandLwm2mProfileRequest;
import com.mh.garrison.entity.AEPEntity;

/**
 * @author 铭汉科技——LJL
 * @date 2022-07-25 10:58
 * @Description
 */
public class PostCmdUtils {

    /**
     * 永阳电表
     * 指令发送至AEP平台执行操作，带profile模型
     */
    public static void postAsyncCmdAEPV1ByProfile(String deviceId, String sendOrderStr, AEPEntity aepEntity) throws Exception {

        AepDeviceCommandLwmProfileClient client = AepDeviceCommandLwmProfileClient.newClient().appKey("eP618B5xol5").appSecret("EdaE776fG6").build();

        {

            CreateCommandLwm2mProfileRequest request = new CreateCommandLwm2mProfileRequest();

            JSONObject jsonObject = new JSONObject();
            JSONObject jsonObject1 = new JSONObject();
            JSONObject jsonObject2 = new JSONObject();

            jsonObject2.put("value", sendOrderStr);

            /**可以去电信指定下发一个设备时选择的各项参数，或者查看AEP文档，又或者查看产品模型*/
            jsonObject1.put("serviceId", "MHMeterData");
            jsonObject1.put("method", "COMMAND");
            jsonObject1.put("paras", jsonObject2);

            jsonObject.put("command", jsonObject1);
            jsonObject.put("deviceId", deviceId);
            jsonObject.put("operator", "admin");
            jsonObject.put("productId", aepEntity.getProductId());
            jsonObject.put("ttl", 7200);
            jsonObject.put("deviceGroupId", aepEntity.getDeviceGroupId());
            jsonObject.put("level", 1);

            request.setBody(jsonObject.toString().getBytes());
            System.out.println(jsonObject.toString());
            System.out.println(client.CreateCommandLwm2mProfile(request));
        }
        client.shutdown();
    }

    /**
     * 创建修改表号指令
     * 永阳电表专用
     * @param meterNum
     * @return
     */
    private static String createUpdateMeter(String meterNum) {
        StringBuilder cmd = new StringBuilder();
        cmd.append("68AAAAAAAAAAAA681506");
        //转换位置
        String afterChange = changePosition(meterNum);
        //加33操作
        String finalMeterNum = addThree(afterChange);
        cmd.append(finalMeterNum);
        //校验码
        String checksum = makeChecksum(cmd.toString());
        cmd.append(checksum);
        //结束符
        cmd.append("16");
        return cmd.toString().toUpperCase();
    }


    /**
     * 转换位置
     */
    private static String changePosition(String data) {
        String newData = "";
        for (int i = data.length() / 2; i > 0; i--) {
            newData = newData + data.substring(2 * i - 2, 2 * i);
        }
        return newData;
    }

    /**
     * 校验码
     */
    private static String makeChecksum(String data) {
        if (data == null || data.equals("")) {
            return "";
        }
        int total = 0;
        int len = data.length();
        int num = 0;
        while (num < len) {
            String s = data.substring(num, num + 2);
            total += Integer.parseInt(s, 16);
            num = num + 2;
        }
        /**
         * 用256求余最大是255，即16进制的FF
         */
        int mod = total % 256;
        String hex = Integer.toHexString(mod);
        len = hex.length();
        // 如果不够校验位的长度，补0,这里用的是两位校验
        if (len < 2) {
            hex = "0" + hex;
        }
        return hex;
    }

    /**十六进制补全2位*/
    private static String zeroFilling(String meterId) {
        meterId = meterId.replace(" ", "");
        StringBuilder str = new StringBuilder(meterId);
        while (str.length() < 2) {
            str.reverse();
            str.append("0");
            str.reverse();
        }
        return String.valueOf(str);
    }

    /**加33操作*/
    private static String addThree(String data) {
        // 33值
        int b = Integer.parseInt("33", 16);
        // 新返回值
        String newData = "";
        for (int i = 0; i < data.length() / 2; i++) {
            String cutString = data.substring(2 * i, 2 * i + 2);
            int a1 = Integer.parseInt(cutString, 16);
            int b1 = a1 + b;
            if (b1 < 0) {
                System.out.println("数据格式有误");
                return "数据格式有误";
            } else {
                b1 = b1 % 256;
                String hexString = Integer.toHexString(b1);
                if (hexString.length() < 2) {
                    hexString = "0" + hexString;
                    newData = newData + hexString;
                } else {
                    newData = newData + hexString;
                }
            }
        }
        return newData;
    }

    /**生成电压功率设定值*/
    private static String createPower(double value){
        String str = String.valueOf(Math.abs(value));

        String[] split = str.split("\\.");
        System.out.println("spilt:"+split);

        String a1 = "00" + split[0];
        String b1 = a1.substring(a1.length() - 2);
        String b2 = (split[1] + "00").substring(0, 2);

        System.out.println("b1:"+b1+"   b2:"+b2);
        System.out.println("b1+33:"+addThree(b1));
        System.out.println("b2+33:"+addThree(b2));

        String power = (addThree(b2) + addThree(b1)).toUpperCase();
        System.out.println(power);
        return power;
    }


    public static void main(String[] args) {
        try {
            //postAsyncSetPower("deviceId001",new AEPEntity(),3.5);
            String cmd = createUpdateMeter("000030702262");
            System.out.println("cmd = " + cmd);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
