package com.mh.garrison.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.mh.garrison.entity.WaterDayBean;
import com.mh.garrison.entity.WaterHistoryBean;
import com.mh.garrison.mapper.WaterDayMapper;

/**
 * service 层
 * @ClassName:  WaterDayService   
 * @Description:TODO 调用waterDayMapper，实现增删查改 
 * @author: 铭汉科技—LJF 
 * @date:   2018年8月3日 下午3:56:40   
 *
 */
@Service
public class WaterDayService {
	
	@Autowired
	private WaterDayMapper waterDayMapper;
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public List<WaterDayBean> findAllWaterDay(){
		return waterDayMapper.findAllWaterDay();
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int findNotUploadNum() {
		return waterDayMapper.findNotUploadNum();
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public List<WaterDayBean> findById(String water_id) {
		return waterDayMapper.findByWaterId(water_id);
	}
	
	// 根据时间查询
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public List<WaterDayBean> findByDate(String water_id, String dateString) {
		return waterDayMapper.findByDate(water_id, dateString);
	}
	
	// 根据时间查询
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public List<WaterDayBean> findByTime(String dateString) {
		return waterDayMapper.findByTime(dateString);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int insert(String water_id) {
		return waterDayMapper.insert(water_id);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int insertAll(WaterHistoryBean waterDayBean) {
		return waterDayMapper.insertAll(waterDayBean);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int update(WaterHistoryBean waterDayBean) {
		return waterDayMapper.update(waterDayBean);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public boolean updateGrade(WaterDayBean waterDayBean) {
		return waterDayMapper.updateGrade(waterDayBean);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int delete(String water_id) {
		return waterDayMapper.delete(water_id);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public String exeProcedure(WaterHistoryBean waterDayBean) {
		return waterDayMapper.exeProcedure(waterDayBean);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public String execProCheack(String waterID) {
		return waterDayMapper.execPro_Cheack_Areas(waterID);
	}

}
