package com.mh.garrison.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.mh.garrison.entity.WaterHistoryBean;
import com.mh.garrison.mapper.WaterHistoryMapper;


/**
 * 
 * @ClassName:  WaterHistoryService   
 * @Description:TODO 对waterHistory表进行数据增删查改   
 * @author: 铭汉科技—LJF 
 * @date:   2018年9月28日 上午9:58:32   
 *
 */
@Service
@Primary
public class WaterHistoryService {
	
	@Autowired
	private WaterHistoryMapper waterHistoryMapper;
	
	// 检查history表中是否有数据
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int checkHistorySame(WaterHistoryBean waterHistoryBean) {
		return waterHistoryMapper.checkSame(waterHistoryBean);
	}
	
	// 插入水表历史数据
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int insertAll(WaterHistoryBean waterHistoryBean) {
		return waterHistoryMapper.insertAll(waterHistoryBean);
	}
	
	// 如果存在同样的数据进行数据更新
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int update(WaterHistoryBean waterHistoryBean) {
		return waterHistoryMapper.update(waterHistoryBean);
	}

	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int checkSame(WaterHistoryBean wtHistoryBean) {
		// TODO Auto-generated method stub
		return waterHistoryMapper.checkSame(wtHistoryBean);
	}

}
