package com.mh.garrison.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.mh.garrison.entity.WaterBean;
import com.mh.garrison.mapper.WaterMapper;


/**
 * 
 * @ClassName:  WaterService   
 * @Description:调用WaterMapper中的方法，实现增删查改   
 * @author: 铭汉科技—LJF 
 * @date:   2018年8月2日 下午3:10:31   
 *
 */
@Service
@Primary
public class WaterServices {
	
	@Autowired
	private WaterMapper waterMapper;
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public List<WaterBean> findAll(){
		return waterMapper.findAllWater();
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public WaterBean findById(String waterId) {
		return waterMapper.findByWaterId(waterId);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int insert(String waterId) {
		return waterMapper.insert(waterId);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int insertAll(WaterBean waterBean) {
		return waterMapper.insertAll(waterBean);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int update(WaterBean waterBean) {
		return waterMapper.update(waterBean);
	}
	
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int delete(String waterId) {
		return waterMapper.delete(waterId);
	}
	
	// 查询IMEI号 2018-09-28 by ljf
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public String findImei(String waterId) {
		return waterMapper.findImei(waterId);
	}
	
	// 查询房间号 2018-09-28 by ljf
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public String findHouse(String waterId) {
		return waterMapper.findHouse(waterId);
	}
	
	// 查询是否有数据 2018-09-28 by ljf
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int findNowSum(String waterId) {
		return waterMapper.findResult(waterId);
	}
	
	// 往水表实时表中插入数据 2018-09-28 by ljf
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int insertNow(WaterBean waterBean) {
		return waterMapper.insertWtNowAll(waterBean);
	}
	
	// 实时水表数据存在相同数据，进行更新 2018-09-28 by ljf
	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int updateWtNow(WaterBean waterBean) {
		System.out.println(waterBean.toString());
		return waterMapper.updateWtNow(waterBean);
	}

	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int findResult(String waterID) {
		// TODO Auto-generated method stub
		return waterMapper.findResult(waterID);
	}

	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT,timeout=36000,rollbackFor=Exception.class)
	public int insertWtNowAll(WaterBean water) {
		// TODO Auto-generated method stub
		return waterMapper.insertWtNowAll(water);
	}
	
	

}
